package erkka;

import javax.swing.JComponent;
import java.awt.event.*;
import java.awt.Cursor;
import java.awt.Point;
import java.util.Vector;
import java.awt.Color;
import java.awt.*;
/**
*<p>Title:        <b>Erkka-Projekti</b></p>
*<p>Description:  This class is a superclass of symbols and lines. </p>
*<p<Copyright:    Copyright (c) 2002, 2005</p>
*@author          Antti Enqvist & Juho Yli-Honkola + Jukka Mntyl 2005
*@version 1.2 setNewField, removeField, setProperty - listty kutsu Erkkalisternerin PropertyChange-metodiin. getNonscandinavianFieldData(int), getNonscandinavianFieldData(String) getFieldData(String) - skandinaavisten merkkien varalle
*/

public class BaseObject extends JComponent implements MouseMotionListener, MouseListener, ComponentListener, ErkkaListener{
  protected ErkkaListener erkkaListener;
  protected HotSpots hotspots = new HotSpots();
  /**
   * If object has focus this value is true
   */
  protected boolean obj_focus = false;
  protected boolean drawYourself=true;
  int ID;
  static int IDstat=0;
  /**
   * A vector which includes all fields
   */
  private Vector Fields = new Vector();
  /**
   * BaseObject color
   */
  public Color color=Color.black;

/**
 * Default constuctor. It raises ID value by one and sets all listeners.
 */
  public BaseObject() {
    ID=IDstat++;
    this.addMouseListener(this);
    this.addMouseMotionListener(this);
    this.addComponentListener(this);
    color = Color.black;
  }

/**
  * Converts  -> aoaue
  * @param s merkkijono, josta poistetaan erikoismerkit
  * @return siivottu merkkijono
  */
  private String removeSpecialChars(String s) {
    if (s.length() < 1)
      return "";
    String sallitut = "qwertyuiopasdfghjklzxcvbnmQWERTYUIOPASDFGHJKLZXCVBNM_0123456789";
    StringBuffer b = new StringBuffer(s);
    // poistetaan numero alusta
    if ("0123456789".indexOf(b.charAt(0)) >= 0)
      if (b.length() > 1)
        b.deleteCharAt(0);
      else
        return "";
    // poistetaan ei-sallitut merkit ja muunnetaan skandit vastaaviksi ei-skandimerkeiksi
    for (int i=0;i<b.length();i++) {
      if (sallitut.indexOf(b.charAt(i)) == -1) {
        b.deleteCharAt(i);
        i--;
        continue;
      }
       switch (b.charAt(i)) {
        case '':
        case '':
        case '':
        case '':
        case '':
          b.setCharAt(i,'A'); break;
        case '':
        case '':
        case '':
        case '':
          b.setCharAt(i,'O'); break;
        case '':
        case '':
        case '':
        case '':
          b.setCharAt(i,'U'); break;
        case '':
        case '':
        case '':
        case '':
          b.setCharAt(i,'E'); break;
        case '':
        case '':
        case '':
        case '':
          b.setCharAt(i,'a'); break;
        case '':
        case '':
        case '':
        case '':
          b.setCharAt(i,'o'); break;
        case '':
        case '':
        case '':
        case '':
          b.setCharAt(i,'u'); break;
        case '':
        case '':
        case '':
        case '':
          b.setCharAt(i,'e'); break;
      }
    }
    return b.toString();
  }


  /**
   * returns objects ID
   * @return object ID
   */
  public int GetID(){return ID;}
    /**
     * sets objects ID.
     * @param id Desired ID
     */
  public void SetID(int id){ID=id;if(IDstat <= id)IDstat=id+1;}

  public void drawYourselfBounds(boolean draw){
    drawYourself=draw;
  }

/**
 * This function sets properties into Fields vector.
 * @param Prop_Data	string which you want to put into vector
 * @param i			index of the place in vector
 */
  public void SetProperty(String Prop_Data,int i){
      Proper p =new Proper(this.getFieldName(i));
      p.setDType(getFieldDataType(i));
      p.setPData(Prop_Data);
      Fields.set(i,p);
      ErkkaEvent w;
      w = new ErkkaEvent(this, ErkkaEvent.PROPERTY_CHANGE);
      if(erkkaListener !=null)
        erkkaListener.PropertyChange(w);
  }
/**
* This function creates new properties and adds them into Fields vector
* @param pName desired property name
* @param pData desired property data
* @param pDType desired data type
* @param index index of the place in Field vector
*/
  public void setNewField(String pName,String pData,String pDType,int index){
      Proper tempProp = new Proper(pName);
    tempProp.setPData(pData);
    //tempProp.setIndex( i);
    tempProp.setDType(pDType);

    Fields.add(index,tempProp);
    ErkkaEvent w;
    w = new ErkkaEvent(this, ErkkaEvent.PROPERTY_CHANGE);
    if(erkkaListener !=null)
        erkkaListener.PropertyChange(w);
  }
/**
* removes object from the Field vector
* @param index of the desired place
*
*/
  public void removeField(int index){

    Fields.remove(index);
      ErkkaEvent w;
    w = new ErkkaEvent(this, ErkkaEvent.PROPERTY_CHANGE);
    if(erkkaListener !=null)
        erkkaListener.PropertyChange(w);
  }

/**
* Sets new property into the Field vector. The place in vector is very last
* @param pName desired name
* @param pData desired Data
* @param pDType desired Data Type
*/
    public void setNewField(String pName,String pData,String pDType){
    Proper tempProp = new Proper(pName);
    tempProp.setPData(pData);
    //tempProp.setIndex( i);
    tempProp.setDType(pDType);

    Fields.add(tempProp);
    ErkkaEvent w;
    w = new ErkkaEvent(this, ErkkaEvent.PROPERTY_CHANGE);
    if(erkkaListener !=null)
     erkkaListener.PropertyChange(w);
    //PropertyName.add(pName); }
  }

/**
* Returns the size of the Field vector
* @return palautettavien kenttien mr
*/
  public int getFieldsCount(){ return Fields.size(); }
  public String getFieldName(int i){
    if (Fields.size()<= i || i < 0)
      return null;
    return ((Proper)Fields.get(i)).getPName();
  }
/**
* Returns an object from the Field vector at the desired index
*
*@param i desired index
*@return antaa datan stringin
*/
  public String getFieldData(int i){
    if (Fields.size() <= i || i < 0)
      return null;
    return ((Proper)Fields.get(i)).getPData();
  }

  /**
  * Returns an object from the Field vector at the desired index
  *
  *@param i desired index
  *@return antaan kentn datan stringin ilman erikoismerkkej
  */
    public String getFieldDataNoSpecials(int i){
      if (Fields.size() <= i || i < 0)
        return null;
      return removeSpecialChars(((Proper)Fields.get(i)).getPData());
    }

    /**
    * Returns an object from the Field vector
    *@param fieldname kentn nimi
    *@return antaa kentn datan stringin ilman erikoismerkkej
    */
    public String getFieldDataNoSpecials(String fieldname){
      return removeSpecialChars(getFieldData(fieldname));
    }

    /**
    * If param Fname equals some of the Field names then this function returns that place
    *
    *@param fieldname field name
    *@return kentn data stringin
    */
      public String getFieldData(String fieldname){
        for(int i=0;i<getFieldsCount();i++){
          if(getFieldName(i).equalsIgnoreCase(fieldname)) {
            return getFieldData(i);
          }
        }
        return "";
      }


/**
* If param Fname equals some of the Field names then this function returns that place
*
*@param Fname desired "search key"
*@return index if found, -1 if not
*/
  public int getDataFieldIndex(String Fname){
    for(int i=0;i<getFieldsCount();i++){
      if(getFieldName(i).equalsIgnoreCase(Fname)) return i;
    }
    return -1;
  }



 /**
 * Returns data type field from Field vector
 * @param i kentn indeksi
 * @return kentn datatyyppi stringin
 */
  public String getFieldDataType(int i){
   return ((Proper)Fields.get(i)).getPDType();
  }

  public void  mousePressed(MouseEvent e){}
/**
* Invokes when mouse button is released
* @param e MouseEvent
*/
  public void mouseReleased(MouseEvent e) {
      setCursor( Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
  }
  /**
   * This function handles mouseClicked event of interface MouseListener.
   * Function is not implemented...
   * @param e MouseEvent
   */
  public void mouseClicked(MouseEvent e) {}

  /**
   * This function handles mouseEntered event of interface MouseListener.
   * This is the right place for changing the mouse cursor for example
   * as a doubleheaded arrow.
   * @param e MouseEvent
   */
  public void mouseEntered(MouseEvent e) {}

  /**
   * This function handles mouseExited event of interface MouseListener.
   * This is the right place for changing the mouse cursor back as normal if
   * it was changed in method mouseEntered()
   * @param e MouseEvent
   */
  public void mouseExited(MouseEvent e) {
  }

  /**
   * This function handles mouseMoved event of interface MouseMotionListener.
   * Not implemented.
   * @param e MouseEvent
   */
  public void mouseMoved(MouseEvent e){
  }

  /**
   * This function handles mouseDragged event of interface MouseMotionListener.
   * Moves the object with mouse dragging operation.
   * @param e MouseEvent
   */
  public void mouseDragged(MouseEvent e){
  }
/**
 *   Invoked when the component's size changes.
 * @param e ComponentEvent
 */
  public void componentResized(ComponentEvent e) {}
  /**
   * Invoked when the component's position changes.
   * @param e ComponentEvent
   */
  public void componentMoved(ComponentEvent e){
  }
  /**
   * Invoked when the component has been made visible.
   * @param e ComponentEvent
   */
  public void componentShown(ComponentEvent e){}
  /**
   *  Invoked when the component has been made invisible.
   * @param e ComponentEvent
   */
  public void componentHidden(ComponentEvent e){}
/**
* Function sets object focus either true or false
*
* @param focus if this param is true then this component gets focus. If it is false
* componen loses it
*/
  public void SetObjectFocus(boolean focus){
    if (focus == obj_focus){return;} //if focus is the same as object_focus
    obj_focus = focus;
    ErkkaEvent w;
    w = new ErkkaEvent(this, ErkkaEvent.BOX_SELECTED);
    erkkaListener.Selected(w);
  }

/**
* Return the middle point of the component
* @return middle point of component
*/
  public Point GetMiddlePoint(){
    int x,y;
    Point middlePoint = new Point();
    middlePoint.x = getX()+(getWidth()/2);
    middlePoint.y = getY()+(getHeight()/2);
    return middlePoint;
   }
    public synchronized void addErkkaListener(ErkkaListener l) {
        erkkaListener = ErkkaEventMulticaster.add(erkkaListener, l);
    }
    public synchronized void removeErkkaListener(ErkkaListener l) {
        erkkaListener = ErkkaEventMulticaster.remove(erkkaListener, l);
    }
  public void Selected(ErkkaEvent e){}
  public void PropertyChange(ErkkaEvent e){}
/**
* Returns object_focus
* @return boolean
*/
public boolean getObjectFocus(){
    return obj_focus;
  }
/**
* Sets the color of the component
* @param col vri
*/
  public void setObjectColor(Color col){
    color = col;
  }
/**
* Defines and draws object color
* @param g mritettvn grafiikan vri
*/
  public void paint(Graphics g){
    g.setColor(color);
  }
}
