package erkka;

import java.awt.event.*;
import java.awt.Color;
import java.awt.*;
import java.util.*;

import com.sun.org.apache.xerces.internal.parsers.DOMParser;
import javax.xml.parsers.*;
import com.sun.org.apache.xerces.internal.*;
import org.w3c.dom.*;
import com.sun.org.apache.xerces.internal.dom.*;
import com.sun.org.apache.xml.internal.serialize.*;

import java.io.*;
import java.awt.image.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.undo.*;

/**
*<p>Title:        <b>Erkka-Projekti</b></p>
*<p>Description:  This class controls the whole application. It have pointers
*to all other classes of the application and all information goes through
*this class. </p>
*<p>Copyright:    Copyright (c) 2002 Erkka-projekti</p>
*@author        Antti Enqvist & Juho Yli-Honkola
*@version 1.2 Jukka Mntyl Muutettu savetusta skandien varalle. Ennen makesql: tarkistetaan kardinaalisuudet ja primary keyt (checkDrawingForErrors). Tm rikkoo hieman ohjelman yleiskyttisyytt.
*/
/*
*<h2>Version history</h2>
*<TABLE border="1" width=80%>
*<TR>
*<TD WIDTH="20%"><b>Version</b></td>
*<TD WIDTH="20%"><b>Date</b></td>
*<TD WIDTH="*"><b>Changes</b></td>
*<TD WIDTH="20%"><b>Person</b></td>
*</TR>
*<TR>
*<TD WIDTH="20%">0.0.1</TD>
*<TD WIDTH="20%">03.03.02</TD>
*<TD WIDTH="*">First version</TD>
*<TD WIDTH="20%">AE</TD>
*</TR>
*</TABLE>
*/

public class Control {

  /**
   * undo system elements
   */
  protected UndoManager undoManager = new UndoManager();  // history list
  protected UndoableEditSupport undoSupport = new UndoableEditSupport(); // event support

  private Symbol foo;

  private TopPanel topPanel;
  private DrawingArea area;
  private InformationPanel infoPanel;
  private BaseObject temp_obj;
  private BaseObject tempo;
  private BaseObject temp;//,DraggedObject;
  private Line temp2;  // temp line
  private int mousepX,mousepY;
  private int dragpX = 0;
  private int dragpY = 0;
  SymbolFactory symbolFactory = new SymbolFactory();
  private Rules rules;
  private NodeList configL;
  private Document doc;
  private boolean dragged = false;
  private ProgresWaitDialog transformationDialog =  new ProgresWaitDialog();


  public Control(DrawingArea area, TopPanel topPanel, InformationPanel info) {
    this.area = area;
    this.topPanel = topPanel;
    this.infoPanel = info;
    transformationDialog.pack();
  }
  /**
   * Init symbolfactory and top panel buttons and colors.
   * @param configL Nodelist where is config elemement(see congig.erkka)
   * @return false if configL is not suitable.
   */
  public boolean initProgram(NodeList configL){
    Element config = ((Element)configL.item(0));
    // If the configuration is missing, we quit. We can't live without it.
    if (config == null)
      return false;

    clearDrawingArea();
    symbolFactory=new SymbolFactory();
    infoPanel.setSymbolF(symbolFactory);
    rules=new Rules(area.getLineTable());

    NodeList objectL, fieldL, nameL,ruleL;
    BaseObject newSymbol;
    String oName="Error in config file";
    Element elem ;
    Node node;
    // read config data
    objectL=config.getElementsByTagName("objectC");
    for (int i = 0; i < objectL.getLength(); i++) {
        Element element = (Element)objectL.item(i);
        oName=element.getAttribute("name");
        // create new symbol in symbolfactory, later we can easy create new instance
        symbolFactory.addNewSymbol(oName,element.getAttribute("type"),
        element.getAttribute("height"),element.getAttribute("width"),element.getAttribute("color"),element.getAttribute("contains"));
        // Init rules
        ruleL=element.getElementsByTagName("rules");
        Element ruleE =(Element)ruleL.item(0);
        // install fields in symbol
        if (ruleE!=null)
          ruleL=ruleE.getElementsByTagName("rule");
          for(int k=0;k<ruleL.getLength();k++){
            ruleE=(Element)ruleL.item(k);
            rules.addNewRule(oName,ruleE.getAttribute("friend"),ruleE.getAttribute("max"));
          }
        fieldL=element.getElementsByTagName("fieldC");
        for(int j=0;j<fieldL.getLength();j++){
            element=(Element)fieldL.item(j);
            if (element.getFirstChild()!=null)
              symbolFactory.initSymbolFields(oName,element.getAttribute("name"),element.getFirstChild().getNodeValue(),element.getAttribute("select"));
            else
              symbolFactory.initSymbolFields(oName,element.getAttribute("name")," ",element.getAttribute("select"));
        }


    }
    Color bgColor=Color.white;
    Color inColor=SystemColor.activeCaptionBorder;
    Color topColor=SystemColor.activeCaptionBorder;
    fieldL=config.getElementsByTagName("colors");
    // try init colors in config
    try{
      elem=(Element)fieldL.item(0);
      if(elem !=null){

        bgColor = Color.decode(elem.getAttribute("bground"));
        inColor =Color.decode(elem.getAttribute("infopanel"));
        topColor= Color.decode(elem.getAttribute("toppanel"));
      }
    }
    catch (Exception exe){ ;}

    area.setBackground(bgColor);
    infoPanel.setBackground(inColor);
    topPanel.setBackground(topColor);
    clearVariables();
    // create buttons in top panel
    for(Enumeration e= symbolFactory.getSymbols();e.hasMoreElements();){
      BaseObject bas = (BaseObject)e.nextElement();
      topPanel.addNewButton(bas.getFieldData(0));
      topPanel.revalidate();
    }
    topPanel.createClearButton();
  // init selection boxes(check and combobox
    objectL=config.getElementsByTagName("selectionbox");
    for (int i = 0; i < objectL.getLength(); i++) {
        Element element = (Element)objectL.item(i);
        oName=element.getAttribute("name");//"datatypes"
        symbolFactory.addNewSelectionBox(oName,element.getAttribute("type"));// combo or check
        ruleL=element.getElementsByTagName("choice");
          for(int k=0;k<ruleL.getLength();k++){
            Element choiceE=(Element)ruleL.item(k);
            if(choiceE.hasChildNodes()){

              NodeList nL=choiceE.getElementsByTagName("extra_data_field");
              Element ex=(Element)nL.item(0);
              symbolFactory.addChoiceInSelection(oName,choiceE.getAttribute("name"),ex.getAttribute("name"),ex.getAttribute("default"));


            }else
              symbolFactory.addChoiceInSelection(oName,choiceE.getAttribute("name"),null,null);
         }
    }
    area.setModified(false);
    // init is ok
    return true;
  }
/**
 * Clear variables.
 */
  public void clearVariables(){
    topPanel.removeAll();
    topPanel.NullSelected();
    infoPanel.setSymbolData(null);
    area.setModified(false);
  }
/**
 * Open drawing from file.
 * @param fileName  Filename
 * @return false if file is not valid.
 */
  public boolean openDrawingInFile(File file){
    //String xmlfile =fileName;
    Element elem ;
    Node node;
    NodeList objectL; NodeList fieldL; NodeList nameL;
    Symbol newSymbol;
    Line newLine;
    String oName="Error saving file";
    int oX=0; int oY=0; int fieldsindex = -1;
    String extrafieldname = "";
    MessageBox msg = null;

    //DOMParser parser = new DOMParser();
    DocumentBuilderFactory dfactory = DocumentBuilderFactory.newInstance();
    try {
       DocumentBuilder dbuilder = dfactory.newDocumentBuilder();
       doc = dbuilder.parse(file);
    }
    catch (org.xml.sax.SAXParseException e)
    {
      msg = new MessageBox();

      msg.setTitle("Error in parsing file "+file.getName());
      msg.askOkay(e.getLocalizedMessage());
      return false;
    }
    catch (Exception e) {
      msg = new MessageBox();

      msg.setTitle("Error in parsing file "+file.getName());
      msg.askOkay(e.getLocalizedMessage());
      return false;
    }

    //doc = parser.getDocument();
    // First create all symbols, lines later
    configL=doc.getElementsByTagName("configuration");

    if (!initProgram(configL)) {
      msg = new MessageBox();

      msg.setTitle("Error in parsing file "+file.getName());
      msg.askOkay("Konfiguraatiotiedosto ei ole kunnossa.\nKuvaa ei voida avata!\n");

      return false;
    }

    objectL=doc.getElementsByTagName("drawing");
    Element drawing = ((Element)objectL.item(0));

    if (drawing == null) {
      msg = new MessageBox();
      msg.setTitle("Error in parsing file "+file.getName());
      msg.askOkay("No <drawing> -element found.");
      return false;
    }
    // get all object element
    objectL = drawing.getElementsByTagName("object");
    for (int i = 0; i < objectL.getLength(); i++) {
        Element element = (Element)objectL.item(i);
        newSymbol=(Symbol)symbolFactory.createSymbol(element.getAttribute("name"));
        fieldL=element.getElementsByTagName("id");
        // in xml-file id value in id55, so remove "id" at begin of text.
        newSymbol.SetID(Integer.parseInt (fieldL.item(0).getFirstChild().getNodeValue().substring(2)));
        fieldL=element.getElementsByTagName("field");
        //set fields value
        for(int j=0;j<fieldL.getLength();j++){
            element=(Element)fieldL.item(j);
            if (element.getFirstChild()!=null){
              // set symbol right place in Darea...
              if((element.getAttribute("name")).equalsIgnoreCase("coordinate_x"))
                oX=Integer.parseInt(element.getFirstChild().getNodeValue());
              else if(element.getAttribute("name").equalsIgnoreCase("coordinate_y")){
                oY=Integer.parseInt(element.getFirstChild().getNodeValue());
                area.AddObj(newSymbol,oX,oY);

                setListeners(newSymbol);// SET MOUSE LISTENERS
              } else {
                // jm: tarkistettava onko kentt olemassa silt varalta, ett se on extra_field
                extrafieldname = element.getAttribute("name");
                fieldsindex = newSymbol.getDataFieldIndex(extrafieldname);
                if (fieldsindex == -1) {
                  // jos kentn nimi on jonkin comboboxin extrafieldeiss,
                  // niin silloin kentt on listtv tlle symbolille
                  // kyseisen comboboxin pern

                  // liittyyk tss symbolissa oleviin kenttiin extra fieldi
                  Proper prop = null;
                  String type = "";
                  for (int z=0;z<newSymbol.getFieldsCount();z++) {
                    type = symbolFactory.getSelectionType(newSymbol.getFieldDataType(z));
                    if (type.equalsIgnoreCase("combobox")) {
                      prop = symbolFactory.getExtraProper(newSymbol.getFieldDataType(z),extrafieldname);
                      if (prop != null) {

                        // jos lytyy niin listn symbolille kentt ja data sen paikan jlkeen jossa kyseinen kentt on

                        // kentan paikka comboboxista seuraava eli z + 1
                        newSymbol.setNewField(extrafieldname,
                                              element.getFirstChild().getNodeValue(),
                                              prop.getPDType(), z + 1);
                        break;
                      }
                    }
                  }
                } else {
                  newSymbol.SetProperty(element.getFirstChild().getNodeValue(),fieldsindex);
                }
              }
            }
          }
        }
    area.setModified(false);
    // make lines
    objectL=doc.getElementsByTagName("join");
    if (objectL == null) {
      return true;
    }
    for (int i = 0; i < objectL.getLength(); i++) {
      Element element = (Element)objectL.item(i);
      newLine=(Line)symbolFactory.createSymbol("Line");
      fieldL=element.getElementsByTagName("idref");
      element=(Element)fieldL.item(0);
      // set target1 symbol that id is in nodevalue
      newLine.SetTarget1(area.getObjByID(Integer.parseInt(element.getFirstChild().getNodeValue().substring(2))));
      setListeners(newLine);
      element=(Element)fieldL.item(1);
      newLine.SetTarget2(area.getObjByID(Integer.parseInt(element.getFirstChild().getNodeValue().substring(2))));
      // if target 1 or 2 is container, we need to call addsymbol method.
      String cont=symbolFactory.isContainer(newLine.GetTarget1().getFieldData(0));
      if(cont!=null){
        if(newLine.GetTarget2().getFieldData(0).equalsIgnoreCase(cont))
          if(newLine.GetTarget1() instanceof SymbolContainer){
            ((SymbolContainer)newLine.GetTarget1()).addSymbol((Symbol)newLine.GetTarget2());
            newLine.drawYourselfBounds(false);
          }
      }
      else{
        cont=symbolFactory.isContainer(newLine.GetTarget2().getFieldData(0));
        if(cont!=null){
          if(newLine.GetTarget1().getFieldData(0).equalsIgnoreCase(cont))
            if(newLine.GetTarget2() instanceof SymbolContainer){
              ((SymbolContainer)newLine.GetTarget2()).addSymbol((Symbol)newLine.GetTarget1());
              newLine.drawYourselfBounds(false);
            }
          }
      }


      element = (Element)objectL.item(i);
      fieldL=element.getElementsByTagName("field");
      element=(Element)fieldL.item(0);
      if(element!=null)
        if (element.getFirstChild() != null)
          newLine.SetProperty(element.getFirstChild().getNodeValue(),1);
       area.AddObj(newLine,1,1);
    }
    area.setModified(false);

    area.revalidate();
    area.repaint();

    area.selectAll();
    area.moveSelectedObjects(0,1);
    area.setFocusVectorNull();
    area.repaint();
    area.requestFocus();
    return true;
  }

  public TopPanel getTopPanel(){ return topPanel;}
  /**
   * Set all needed listeners to symbol.
   * @param newSymbol
   */

  public  void setListeners(BaseObject newSymbol){

      newSymbol.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mousePressed(MouseEvent e) {
        obj_mousePressed(e);
     }
      });
      newSymbol.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseEntered(MouseEvent e) {
        obj_mouseEntered(e);
        }
      });
      newSymbol.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseReleased(MouseEvent e) {
        obj_mouseReleased(e);
        }
      });

      newSymbol.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseExited(MouseEvent e) {
        obj_mouseExited(e);
        }
      });

      newSymbol.addMouseMotionListener(new java.awt.event.MouseMotionListener(){
      public void mouseDragged(MouseEvent e) {
        obj_mouseDragged(e);
        }
      public void mouseMoved(MouseEvent e){}
      });
  }

  /**
   * Add Symbol given place. Ask symbol type in top panel and ask symbolfactory
   * create it.
   * @param CoordX
   * @param CoordY
   * @param e
   */
  public void AddComponent(int CoordX,int CoordY,MouseEvent e)
  {
    if (!e.isControlDown())
      area.setFocusVectorNull();
    // right mouse button sets toppanel button up.
    if(!((e.getModifiers() & InputEvent.BUTTON3_MASK) ==0)){
      temp2=null;
      area.setLine(0,0,0,0);
      topPanel.NullSelected();
    }

    String SelectedName;
    SelectedName = topPanel.GetSelected();
    if (SelectedName == null || SelectedName.length() == 0){
      infoPanel.setSymbolData(null);
      return;
    }
    // if some button is down, then create symbol
    temp_obj = symbolFactory.createSymbol(SelectedName);
    if(!(temp_obj instanceof Line)){
      setListeners(temp_obj);
      area.AddObj(temp_obj,CoordX,CoordY);

      // KKL: Here we handle adding undo information for this object
      UndoableEdit edit = new AddEdit(area, temp_obj );
      // notify the listeners
      undoSupport.postEdit( edit );
      // End undo code

      temp_obj.SetObjectFocus(true);
      infoPanel.setSymbolData(((BaseObject)temp_obj));
      area.repaint();

    }
    area.requestFocus();
  }

  public void obj_mouseEntered(MouseEvent e){
    if (topPanel.GetSelected() == null ) return;
    // set focus true if try to connect line to symbol
    if (topPanel.GetSelected().equalsIgnoreCase("line")){
      if(e.getComponent() instanceof Symbol){
        foo = ((Symbol)e.getComponent());
        foo.SetObjectFocus(true);
        foo.repaint();
        area_MouseMoved(e.getX()+foo.getX(),e.getY()+foo.getY());
      }
    }
  }
  public void obj_mouseExited(MouseEvent e){
    if (topPanel.GetSelected() == null ) return;
    if (topPanel.GetSelected().equalsIgnoreCase("line") ){
      foo.SetObjectFocus(false);
      foo.repaint();
    }

  }
/**
 *  Handle all symbol click events. Select symbol active or add symbol in
 *  container or connect line.
 * @param e
 */
  public void obj_mousePressed(MouseEvent e){

    mousepX=e.getX(); mousepY=e.getY();
    if(!((e.getModifiers() & InputEvent.BUTTON3_MASK) ==0)){
      temp2=null;
      area.setLine(0,0,0,0);
      topPanel.NullSelected();
    return;
    }

    // user want drawline to somewhere
    if(topPanel.GetSelected().equalsIgnoreCase("line") && (e.getComponent() instanceof Symbol) ){
      area.setFocusVectorNull();
      area.repaint();
      if (temp2 !=null ){ // check if user already has connect other target
        // if cant join then return
        if(rules.canJoin(temp2.GetTarget1(),(Symbol)e.getComponent())){
          temp2.SetTarget2(((Symbol)e.getComponent()));
          area.AddObj(temp2,0,0);
          temp2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(MouseEvent e) {
              obj_mousePressed(e);
            }
          });
          area.setLine(0,0,0,0);

          // KKL: Here we handle adding undo information for this object
          UndoableEdit edit = new AddEdit(area, temp2 );
          // notify the listeners
          undoSupport.postEdit( edit );
          // End undo code
          ((Symbol)e.getComponent()).SetObjectFocus(false);
          area.repaint();
          temp2 = null;
        }
        else
          return;

      } else {                 // Line follows cursor
        temp2=((Line)symbolFactory.createSymbol("Line"));
        area.addMouseMotionListener(new java.awt.event.MouseMotionListener(){
          public void mouseDragged(MouseEvent e) {}
          public void mouseMoved(MouseEvent e){area_MouseMoved(e);}
        });
        try{
          temp2.SetTarget1(((Symbol)e.getComponent()));// Line get target,
        }
        catch (Exception er){}
      }                                   //it need other target(later click)

    } else{   // else means that we not try draw line
      temp=((BaseObject)e.getComponent());
      // check if adding symbol inside container
      String cont=symbolFactory.isContainer(temp.getFieldData(0));
      if(null!=cont){
        int x=e.getX();
        int y=e.getY();
        if(cont.equalsIgnoreCase(topPanel.GetSelected())){
          BaseObject ba=symbolFactory.createSymbol(topPanel.GetSelected());
          Line l=(Line)symbolFactory.createSymbol("Line");
          l.SetTarget1((Symbol)temp);
          l.SetTarget2((Symbol)ba);
          l.drawYourselfBounds(false);
          ba.drawYourselfBounds(false);
          area.AddObj(l,5,5);
          area.AddObj(ba,10,10);
          ((SymbolContainer)temp).addSymbol((Symbol)ba);
        }
        else {
          BaseObject b=temp;
         // count what attribute is clicked if source is container
          for(int i=0;i<((SymbolContainer)temp).table.size();i++){
            BaseObject base=(BaseObject)((SymbolContainer)temp).table.get(i);
            if( (base.getY()-temp.getY())<y && (base.getY()-temp.getY()+base.getHeight())>y){
              temp=base;
              break;
            }
          }
        }
      }
      // multiselect
      if (e.isControlDown()&&temp.getObjectFocus()){
        dragpX = area.getFocusTableLeft();
        dragpY = area.getFocusTableTop();
        // area.removeObjectFromVector(temp);
      } else if (e.isControlDown()){
        temp.SetObjectFocus(true);
        dragpX = area.getFocusTableLeft();
        dragpY = area.getFocusTableTop();
        infoPanel.setSymbolData(((BaseObject)temp));
        //if selected more than one symbol, hide data
        if(area.FocusVector.size()>1)
          infoPanel.setSymbolData(null);
      } else{
        area.setFocusVectorNull();
        temp.SetObjectFocus(true);
        dragpX = area.getFocusTableLeft();
        dragpY = area.getFocusTableTop();
        infoPanel.setSymbolData(((BaseObject)temp));
      }
      area.repaint();
    }
  }
/**
 * Move selected symbols
 * @param e
 */
  public void obj_mouseDragged(MouseEvent e){
    if ((((BaseObject)e.getComponent()).getObjectFocus()) == true){
      int mx = e.getX()-mousepX;
      int my = e.getY()-mousepY;

      area.moveSelectedObjects( mx, my );
      dragged = true;
    }
    area.repaint();
   }


  public void obj_mouseReleased(MouseEvent e){
    if (!dragged)
      return;
    // KKL: Here we handle adding undo information for this object
    UndoableEdit edit = new MoveEdit(area, area.getFocusVector(), dragpX, dragpY);
    // notify the listeners
    undoSupport.postEdit( edit );
    // End undo code
    dragged = false;

  }

  public void area_MouseMoved(MouseEvent e){
    area_MouseMoved(e.getX(),e.getY());
  }
/**
 * Move line if we are drawing line.
 * @param x
 * @param y
 */
  public void area_MouseMoved(int x, int y){
    if (temp2 !=null){
      if( ! (symbolFactory.createSymbol(topPanel.GetSelected()) instanceof Line)){
        temp2=null;
        area.setLine(0,0,0,0);
        area.repaint();
        return;

      }

      area.setLine(temp2.GetTarget1().GetMiddlePoint().x,temp2.GetTarget1().GetMiddlePoint().y,x,y);
      area.repaint();
    }
  }

  public void keyType(KeyEvent e) {

  }
/**
 * Hide all lines hotspot.
 */
  public void hideAllHotSpots(){
    area.hideLineHotSpots();
  }
  /** jm
   * @return onko piirrosalueeseen tehty muutoksia
   */
  public boolean isAreaModified() {
    return area.getModified();
  }

/**
 *
 * @param fileName Savefile name
 * @param changeState
 * @return false if cannot save.
 */
  public boolean saveDrawingInFile(String fileName, boolean changeState) {
    MessageBox msg = null;
    try{                                                    // ei sisennyst\uFFFD ?
      // init
      OutputFormat format =new OutputFormat(Method.XML,"utf-8",true);
      FileOutputStream out =new FileOutputStream(fileName);
      XMLSerializer serial =new XMLSerializer(out,format);
      serial.asDOMSerializer();
      // saving

      Document the_doc = getAllSymbolsInDoc();
      if (the_doc == null ) {
        msg = new MessageBox();
        msg.setTitle("Error in saving file "+fileName);
        msg.askOkay("Cannot find any data to be saved.");
        //throw new Exception("Error in saving file " + fileName + ". There is no data to be saved.");
        return false;
      }

      serial.serialize(doc); // call method, returns Document
      out.close();
    }
    catch (Exception e) {
      msg = new MessageBox();
      msg.setTitle("Error in saving file "+fileName);
      msg.askOkay(e.getLocalizedMessage());
      return false;
   }

    if (changeState)
      area.setModified(false);
    return true;
  }

/**
 * Returns Document where is all symbols in xml-format.
 * @return doc
 */
  public Document getAllSymbolsInDoc(){
    NodeList n,m;
    if (doc == null)
      return null;

   // Save colors
    m=doc.getElementsByTagName("configuration");
    n=doc.getElementsByTagName("colors");
    Element color=(Element)n.item(0);
    if(color !=null){
      color.setAttribute("bground",String.valueOf(area.getBackground().getRGB()));
      color.setAttribute("infopanel",String.valueOf(infoPanel.getBackground().getRGB()));
      color.setAttribute("toppanel",String.valueOf(topPanel.getBackground().getRGB()));
   }

    m=doc.getElementsByTagName("configuration");
    color =(Element)m.item(0);
    if(color!=null) // SHOULD NEVER BE null !!
     m=color.getElementsByTagName("object");
     for(int i=0;i<m.getLength();i++){
        Element object=(Element)m.item(i);
        object.setAttribute("color",String.valueOf((symbolFactory.createSymbol(object.getAttribute("name")).color.getRGB())));
      }


    n=doc.getElementsByTagName("drawing");
    m=doc.getElementsByTagName("erkka");

    // !!! YOU CAN'T EXPECT THAT THERE IS VALUES IN M.
    Element erkkaE = ((Element)m.item(0));
    // WHAT IF erkkaE IS NOW NULL!!!
    if(n.getLength()>0)
      erkkaE.removeChild((Node)n.item(0));

    Element rootE = doc.createElement("drawing");
    erkkaE.appendChild(rootE);
    Element obj,field;
    BaseObject o;
   String fdata, fname;

  // Save all Symbol that are top of draving area
    for(int i=0;i<area.getComponentCount();i++){
      if((area.getComponent(i)) instanceof Symbol){
        o=(BaseObject)area.getComponent(i);
        obj=doc.createElement("object");
        rootE.appendChild(obj);
        obj.setAttribute("name",o.getFieldData(0));

        field =doc.createElement("id");
        obj.appendChild(field);
      //field.setAttribute("value","id"+String.valueOf(o.GetID()));
        field.appendChild(doc.createTextNode("id"+String.valueOf(o.GetID())));

        field =doc.createElement("field");
        obj.appendChild(field);
        field.setAttribute("name","coordinate_x");
        field.appendChild(doc.createTextNode(String.valueOf(o.getX())));

        field =doc.createElement("field");
        obj.appendChild(field);
        field.setAttribute("name","coordinate_y");
        field.appendChild(doc.createTextNode(String.valueOf(o.getY())));
        // save field data, not save empty

        for(int j=1;j<o.getFieldsCount();j++){
          if (o.getFieldData(j)!=null&&o.getFieldData(j).trim().length()>0){
            field =doc.createElement("field");
            obj.appendChild(field);
            fname = o.getFieldName(j);
            field.setAttribute("name",fname);
            // poistetaan nimist erikoismerkit ja listn default-merkkijonoon lainausmerkit
            if (fname.equals("name"))
              fdata = o.getFieldDataNoSpecials(j);
            else if (fname.equals("value")) {
              fdata = o.getFieldData(j);
              if (fdata.length() > 0 && "0123456789".indexOf(fdata.charAt(0)) == -1) {
                if (fdata.charAt(0) != '\'')
                  fdata = '\'' + fdata;
                if (fdata.charAt(fdata.length() - 1) != '\'')
                  fdata = fdata + '\'';
              }
            } else
              fdata = o.getFieldData(j);
            field.appendChild(doc.createTextNode(fdata));
          }
        }
      }
      // Save all lines
      else if((area.getComponent(i)) instanceof Line){ // line
        o=(BaseObject)area.getComponent(i);
        obj=doc.createElement("join");
        rootE.appendChild(obj);
        obj.setAttribute("name","normal");

        field =doc.createElement("id");
        obj.appendChild(field);
        field.appendChild(doc.createTextNode("id"+String.valueOf(o.GetID())));
        field =doc.createElement("idref");
        obj.appendChild(field);
        field.setAttribute("name","idref1");
        field.appendChild(doc.createTextNode("id"+String.valueOf(((Line)o).GetTarget1().GetID())));

        field =doc.createElement("idref");
        obj.appendChild(field);
        field.setAttribute("name","idref2");
        field.appendChild(doc.createTextNode("id"+String.valueOf(((Line)o).GetTarget2().GetID())));
        for(int j=1;j<o.getFieldsCount();j++){
          if (o.getFieldData(j)!=null&&o.getFieldData(j).trim().length()>0){
            field =doc.createElement("field");
            obj.appendChild(field);
            // poistetaan nimist erikoismerkit ja listn default-merkkijonoon lainausmerkit
            fname = o.getFieldName(j);
            field.setAttribute("name",fname);
            if (fname.equals("name"))
              fdata = o.getFieldDataNoSpecials(j);
            else if (fname.equals("value")) {
              fdata = o.getFieldData(j);
              if (fdata.length() > 0 && "0123456789".indexOf(fdata.charAt(0)) == -1) {
                if (fdata.charAt(0) != '\'')
                  fdata = '\'' + fdata;
                if (fdata.charAt(fdata.length() - 1) != '\'')
                  fdata = fdata + '\'';
              }
            } else
              fdata = o.getFieldData(j);

            field.appendChild(doc.createTextNode(fdata));
          }
        }
      }
    }
    return doc;
  }

  /**
   * Check and reports (msgbox) if cardinalies and primary keys aren't ok
   * @throws Exception with errorstring if there are errors in ER diagram, "" if none
   * */
  public void checkDrawingForErrors() throws Exception {

    //Element rootE = doc.createElement("drawing");
    //erkkaE.appendChild(rootE);
    Element obj,field;
    //BaseObject o;
    BaseObject o = null;
    Line l = null;
    String str;
    Set validentities = new HashSet();
    Set nonvalidentities = new HashSet();

    // kydn lpi kaikki piirroksen elementit
    for(int i=0;i<area.getComponentCount();i++){
      // o.getFieldData(0):sta joka kertoo tyypin. Ilmeisesti silti tytyy tarkistaa onko Symbol.
      if ((area.getComponent(i)) instanceof BaseObject) {

        o = (BaseObject)area.getComponent(i);
        if (o.getFieldData(0).equals("Entity")) {
          if (!validentities.contains(o))
           nonvalidentities.add(o);
        }

        if (o.getFieldData(0).equals("Line")) { // line
          l = (Line) o;
          // jos viivassa on kiinni suhde ja kohde niin silloin pit olla kardinaalisuus
          // ei pitisi olla null
          if (l.GetTarget1() != null && l.GetTarget2() != null) {
            // mink tyyppinen kytkent on kyseess
            if (l.GetTarget1().getFieldData(0).equals("Relationship") &&
              l.GetTarget2().getFieldData(0).equals("Entity")) {
              // onko kardinaalisuudessa merkint
              str = l.getFieldData("cardinality");
              if (! (str.equals("1") || str.equals("M"))) {
                str = l.GetTarget1().getFieldData("name");
                if (str.length() > 0)
                  throw new Exception("Cardinalities are not set near relation '" + str + "'.");
                else
                  throw new Exception("Cardinalities are not set near some relation.");
              }
            }
            if (l.GetTarget1().getFieldData(0).equals("Entity")) {
              if (l.GetTarget2().getFieldData(0).equals("Attribute")) {
                str = l.GetTarget2().getFieldData("primarykey");
                if (str.equals("true")) {
                  if (nonvalidentities.contains(l.GetTarget1()))
                    nonvalidentities.remove(l.GetTarget1());
                  validentities.add(l.GetTarget1());
                }
              }
            }
            // samat toisinpin (thnkin jotain jrkevmp?)
            if (l.GetTarget2().getFieldData(0).equals("Relationship") &&
              l.GetTarget1().getFieldData(0).equals("Entity")) {
              // onko kardinaalisuudessa merkint
              str = l.getFieldData("cardinality");
              if (! (str.equals("1") || str.equals("M"))) {
                str = l.GetTarget2().getFieldData("name");
                if (str.length() > 0)
                  throw new Exception("Cardinalities are not set near relation '" + str + "'.");
                else
                  throw new Exception("Cardinalities are not set near some relation.");
              }
            }
            if (l.GetTarget2().getFieldData(0).equals("Entity")) {
              if (l.GetTarget1().getFieldData(0).equals("Attribute")) {
                str = l.GetTarget1().getFieldData("primarykey");
                if (str.equals("true"))
                  if (nonvalidentities.contains(l.GetTarget2()))
                    nonvalidentities.remove(l.GetTarget2());
                  validentities.add(l.GetTarget2());
          //        m.add(.GetTarget2().getFieldData("name"), new Boolean(true));
              }
            }

          }

        }
      }
    }
    if (!nonvalidentities.isEmpty()) {
      Iterator i = nonvalidentities.iterator();
      str = "";
      while (i.hasNext())
        str = str + " " + ((BaseObject)i.next()).getFieldData("name");
      throw new Exception("Primary key is missing in the following entities:\n" + str);
    }
  }


/**
 * Clear area and variables.
 */
  public void clearDrawingArea(){
    area.removeAll();
    area.clearAllVariables();
    symbolFactory = null;
    infoPanel.setSymbolData(null);
    area.repaint();
  }

/**
 * Occurs when MenuItem "new" is pressed.
 * @param fileName
 */
  public void createNewPicture(String fileName){
    DOMParser parser = new DOMParser();
    // parse file
    try {
       parser.parse(fileName);
    }
    catch (Exception e) {
      MessageBox msg = new MessageBox();
      msg.setTitle("Error in parsing file "+fileName);
      msg.askOkay(e.getLocalizedMessage());
      return;
    }
    doc = parser.getDocument();
    configL = doc.getElementsByTagName("configuration");
    // init program
    if (!initProgram(configL)) {
      MessageBox msg = new MessageBox();
      msg.setTitle("Got some problems.");
      msg.askOkay("The configuration file format is wrong!!");
      return;
    }
    area.setModified(false);
  }


  public void setInfoPanelColor(Color newcol){
    infoPanel.setBackground(newcol);
  }

  public void setDrawingAreaColor(Color newcol){
    area.setBackground(newcol);
    area.setModified(true);
  }

  public void setLineColor(Color newcol){
    area.getLine().setLineColor(newcol);
    area.setModified(true);
  }
  public void print(){
    PrintUtilities.printComponent(area);
  }
  /**
   * Save picture as png to given file
   * @param fileName
   * @param _area
   */
  public void export(String fileName, DrawingArea _area){
    _area.setFocusVectorNull();
    int w = _area.getWidth();
    int h = _area.getHeight();
    BufferedImage i = new BufferedImage(w,h, BufferedImage.TYPE_INT_BGR );
    _area.paint(i.getGraphics());
    byte[] pngbytes;
    PngEncoderB png = new PngEncoderB(i, false, PngEncoderB.FILTER_NONE, 5);
    try {
      FileOutputStream outfile = new FileOutputStream( fileName );
      pngbytes = png.pngEncode();
      if (pngbytes == null) {
        System.out.println("Null image");
      } else {
        outfile.write( pngbytes );
      }
      outfile.flush();
      outfile.close();
    }
    catch (IOException e) {
      e.printStackTrace();
    }
  }
/**
 * Change selected objects color.
 * @param newcol
 */
  public void setSelectedColor(Color newcol){
    for (int i=0;i<area.getFocusVectorSize();i++){
      area.getObject(i).setObjectColor(newcol);
    area.setModified(true);
  }
    area.repaint();
}
/**
 * Make sql transformation. Set listener to recieve results.
 */
  public void makesql() throws Exception {

      checkDrawingForErrors();
      // 2.2.2005 fixed bug in transformation (if you select view | sql)
      if (!saveDrawingInFile("temp.tmp", false))
        throw new Exception("ER-diagram could not be saved. Configuration file (*.erkka) is not probably selected.");
      transformationDialog.doTransformation("temp.tmp");

  }

  public void setSQLTransformFinishedListener(ChangeListener l) {
    transformationDialog.setStateChangeListener(l);
  }

  public UndoManager getUndoManager() { return undoManager; }

  public void setUndoListener(UndoableEditListener listener) {
    undoSupport.addUndoableEditListener(listener);
  }

  public void deleteSelectedObjects() {
    //KKL: Here we handle adding undo information for this object
    UndoableEdit edit = new RemoveEdit(area, area.getFocusVector());
    // notify the listeners
    undoSupport.postEdit( edit );
    // End undo code

    area.removeSelectedObjects(); temp = null;
    infoPanel.setSymbolData(null);
  }

  public void selectAll() {
    area.selectAll();
  }
  /**
   * Tells if drawing has been modified
   * @return area.isModifiedAfterLastAsking
   */
  public boolean isDravingModifiedAfterLastAsking(){

  return area.isModifiedAfterLastAsking();
  }

  public void editSelected(){
    if (area.FocusVector.size()!=1) return;
      infoPanel.setFocus();
  }
}
