package erkka;

import java.awt.*;
import javax.swing.*;
import java.util.*;




/**
*<p>Title:        <b>Erkka-Projekti</b></p>
*<p>Description: This class defines drawing area of the application. Symbols
*and lines are over it.</p>
*<p<Copyright:    Copyright (c) 2002</p>
*@author          Antti Enqvist & Juho Yli-Honkola
*@version 1.2 Listty objektien lismisen yhteyteen event-listeriin PropertyChange-toiminnallisuus. Jukka Mntyl
*/

public class DrawingArea extends JPanel {
  private boolean Modified, modifiedAfterLastAsking;
  private int xx1,xx2,yy1,yy2;
/** a vector which includes all selected objects */
  Vector FocusVector = new Vector();

 /** a vector which includes all lines */
  private Vector LineTable =new Vector();

  /**
   * Default constuctor
   */
  public DrawingArea() {
   this.setLayout(null);
   Modified = false;
   modifiedAfterLastAsking =false;
  }

  /**
   * Function sets start and end points of the line.
*@param x1  start point of the x-coordinate
*@param y1  start point of the y-coordinate
*@param x2  end point of the x-coordinate
*@param y2  end point of the y-coordinate
*/
  public void setLine(int x1,int y1,int x2,int y2){
    xx1=x1;
    xx2=x2;
    yy1=y1;
    yy2=y2;
  }

 /**
 * paint method of the class. Function also draws all lines between objects.
 * points of the lines are xx1,xx2,yy1,yy2
 */
  public void paint(Graphics g){
    super.paint(g);

    for (int j=0;j<LineTable.size();j++){
      ((Line)LineTable.elementAt(j)).PaintThis(g);
    }
    g.drawLine(xx1,yy1,xx2,yy2);
  }



  /**
   * This fuction adds param object in to the object or line table.
* @param obj an object which you want to add in to area
* @param x object x-coordinate
* @param y object y-coordinate
*/

  public void AddObj(BaseObject obj, int x, int y){
    setModified( true );
    if( !(obj instanceof Line)){
      obj.addErkkaListener(new ErkkaListener() {public void Selected(ErkkaEvent e){Symb_selected(e);} public void PropertyChange(ErkkaEvent e) {Symb_changes(e);}} );
//      obj.addErkkaListener(new ErkkaListener() {public void PropertyChange(ErkkaEvent e) {Symb_changes(e);}});
      this.add(obj);
      obj.setBounds(x,y,obj.getWidth(),obj.getHeight());
    }
//if param is line then it will be added in to line table
    else{
      LineTable.add(obj);
      this.add(obj);
      obj.addErkkaListener(new ErkkaListener() {public void Selected(ErkkaEvent e){Symb_selected(e);} public void PropertyChange(ErkkaEvent e) {Symb_changes(e);}} );
     // obj.addErkkaListener(new ErkkaListener() {public void Selected(ErkkaEvent e) {Symb_selected(e);}});
    }
  }
  public void Symb_changes(ErkkaEvent e){
    setModified(true);
  }
/**
* this function clears all variables and removes all objects from line and focus vector
*/
  public void clearAllVariables(){
    LineTable.removeAllElements();
    FocusVector.removeAllElements();
    xx1=0;
    xx2=0;
    yy1=0;
    yy2=0;
  }

  /**
   * This function removes an object from drawing area
   * @param obj object which will be removed from drawing area
   */
  public void removeObj(BaseObject obj){
    setModified(true);

    if ( obj instanceof Line )
      LineTable.remove(obj);

    remove(obj);
    repaint();
  }

/**
* This function will be called when symbol is selected
*/
  public void Symb_selected(ErkkaEvent e){
    if (((BaseObject)e.getSource()).getObjectFocus())
      FocusVector.add(((BaseObject)e.getSource()));
  }

/**
* This function removes all object which are selected.
*
*
*/
  public void removeSelectedObjects(){
    setModified(true);
    BaseObject bas;
    for (int j=0;j<FocusVector.size();j++){
      for(int i=0;i<LineTable.size();i++){
        bas=(BaseObject)FocusVector.elementAt(j);
        if(bas instanceof SymbolContainer){
          SymbolContainer sc= (SymbolContainer)bas;
          for(int k=0;k<sc.table.size();k++){
            remove((BaseObject)sc.table.get(k));
          }
        }
        else
          removeFromContainer(bas);
        if ((((Line)LineTable.elementAt(i)).GetTarget1() == FocusVector.elementAt(j))||
           (((Line)LineTable.elementAt(i)).GetTarget2() == FocusVector.elementAt(j))){
            this.remove((Line)LineTable.elementAt(i));
            LineTable.remove(i); i--;
          }
        }
        if( FocusVector.elementAt(j) instanceof Line)
          LineTable.remove(FocusVector.elementAt(j));
        remove((BaseObject)FocusVector.elementAt(j));
      }
    repaint();
  }

  public void removeFromContainer(BaseObject base){
    for(int i=0;i<getComponentCount();i++){
      if(getComponent(i) instanceof SymbolContainer){
        SymbolContainer con=(SymbolContainer)getComponent(i);
        for(int j=0;j<con.table.size();j++){
          if(con.table.get(j)==base)
            con.deleleSymbol(j);

        }
      }
    }
  }

/**
* returns desired object from focus vector
* @param i desired index
*
*/
  public BaseObject getObject (int i){
    return ((BaseObject)FocusVector.elementAt(i));
  }
/**
* this function will clear focus vector.
*/
  public void setFocusVectorNull(){
    for (int i=0;i<FocusVector.size();i++) {
      ((BaseObject)FocusVector.elementAt(i)).SetObjectFocus(false);
    }
    FocusVector.removeAllElements();
    repaint();
  }

/**
 * Function removes param rem from FocusVector. It also sets rem focus status to false.
* @param rem object which will be removed from focus vector
*/
  public void  removeObjectFromVector(BaseObject rem){
    rem.SetObjectFocus(false);
    FocusVector.remove(rem);
  }

/**
 * This function return the size of the FocusVector
 */

  public int getFocusVectorSize(){
    return FocusVector.size();
  }


  /**
   * If attribute status is false, this function hides all HotSpots of lines.
   */

  public void hideLineHotSpots(){
    if (LineTable.size()>0){
      boolean status = ((Line)LineTable.elementAt(0)).getHotSpotStatus();
        for (int i=0;i<LineTable.size();i++)
          ((Line)LineTable.elementAt(i)).isHotSpotShown(!status);
        this.repaint();
    }
  }
/**
 * Function returns most left point of the focus table
 * @return most left point
 */
  public int getFocusTableLeft(){
    int left = 0;
    BaseObject obj;

    if ( FocusVector.size() == 0)
      return 0;

    left = ((BaseObject)FocusVector.elementAt(0)).getX();

    for (int i=1;i<FocusVector.size();i++){
      obj = (BaseObject)FocusVector.elementAt(i);
      if ( obj.getX() < left)
        left = obj.getX();
    }
    return left;
  }

/**
 * Function returns most right point of the focus table
 * @return
 */

  public int getFocusTableRight(){
    int right = this.getX();
    int testx = 0;
    BaseObject obj;

    for (int i=0; i<FocusVector.size();i++){
      obj = (BaseObject)FocusVector.elementAt(i);
      if (obj != null)
        testx = obj.getX()+obj.getWidth();
      if ( testx > right )
        right = testx;
    }
    return right;
  }

/**
 * Function returns most top point of the focus table
 * @return
 */
  public int getFocusTableTop(){
    int top = 0;
    BaseObject obj;

    if ( FocusVector.size() == 0)
      return 0;

    top = ((BaseObject)FocusVector.elementAt(0)).getY();

    for (int i=1;i<FocusVector.size();i++){
      obj = (BaseObject)FocusVector.elementAt(i);
      if ( obj.getY() < top)
        top = obj.getY();
    }
    return top;
  }

/**
 * Function returns most bottom point of the focus table
 * @return
 */

  public int getFocusTableBottom(){
    int bottom = this.getY();
    BaseObject obj;

    for (int i=0;i<FocusVector.size();i++){
      obj = (BaseObject)FocusVector.elementAt(i);
      if ((obj.getY()+obj.getHeight()) > bottom)
        bottom = obj.getY()+obj.getHeight();
    }
    return bottom;
  }

/**
* returns focus vector
*/
  public Vector getFocusVector() { return FocusVector; }

  public void setFocusVector( Vector newVector ) { FocusVector = newVector; }

/**
* this function returns an object which have desired id. If object haven't be found
* this function return null
*@param id
*/
  public Symbol getObjByID(int id){
    for(int i=0;i<getComponentCount();i++){
      if(getComponent(i) instanceof Symbol && ((Symbol)getComponent(i)).GetID()==id)
        return (Symbol)getComponent(i) ;
    }
    return null;
  }
/**
* this function returns first line from line table
*/
  public Line getLine(){ return (Line)LineTable.elementAt(0); }

/**
* this function returns line table
*/
  public Vector getLineTable() { return LineTable; }

/**
* returns a modified status
*/
  public boolean getModified() {
    return Modified;
  };

  public boolean isModifiedAfterLastAsking(){
  if(modifiedAfterLastAsking){
    modifiedAfterLastAsking=false;
    return true;
  }
  return false;

  }
  public void setModified(boolean newVal) {
    Modified=newVal;
    modifiedAfterLastAsking=newVal;
  }

  /**
   * Moves objects which are in <code>FocusVector</code> to given coordinates.
   *
   * @param dx New x coordinate for the selection
   * @param dy New y coordinate for the selection
   */
  public void setSelectedObjectsPos( int dx, int dy ) {
    int mx, my;

    if ( dx < 0 ) {
      dx = getFocusTableLeft();
    }

    if ( dy < 0 ) {
      dy = getFocusTableTop();
    }

    mx = dx - getFocusTableLeft();
    my = dy - getFocusTableTop();


    if (  dx > 0 || dy > 0){
      for (int i=0;i<getFocusVectorSize();i++){
        int x = getObject(i).getX()+mx;
        int y = getObject(i).getY()+my;
        getObject(i).setBounds(x,y,getObject(i).getWidth(),getObject(i).getHeight());
      }
      setModified(true);
      setPreferredSize( new Dimension(Math.max(getFocusTableRight(), getWidth()),
                                              Math.max(getFocusTableBottom(), getHeight() )));
      revalidate();
    } // if
    invalidate();
  }

/**
* this function will moves all selected objects
*
*/
  public void moveSelectedObjects( int mx, int my ) {
    int dx = getFocusTableLeft()+mx;
    int dy = getFocusTableTop()+my;

    if ( dx < 0 ) {
      mx = -getFocusTableLeft();
      dx = -mx;
    }

    if ( dy < 0 ) {
      my = -getFocusTableTop();
      dy = -my;
    }

    if (  dx > 0 || dy > 0){
      for (int i=0;i<getFocusVectorSize();i++){
        int x = getObject(i).getX()+mx;
        int y = getObject(i).getY()+my;
        getObject(i).setBounds(x,y,getObject(i).getWidth(),getObject(i).getHeight());
      }
      setModified(true);
      setPreferredSize( new Dimension(Math.max(getFocusTableRight(), getWidth()),
                                              Math.max(getFocusTableBottom(), getHeight() )));
      revalidate();
    } // if
    repaint();
  }

 /**
* select all objects
*/
 public void selectAll() {
    Component t[] = this.getComponents();
    for (int i=0; i < this.getComponentCount(); i++) {
      BaseObject b = (BaseObject)t[i];
      b.SetObjectFocus(true);
    }
    repaint();
  }
}
