package erkka;

import javax.swing.JComponent;
import java.awt.*;
import java.util.*;
import java.awt.event.*;
/**
 * Title:        Erkka-Projekti
 * Description:	This class defines how line will be drawn.
 * Copyright:    Copyright (c) 2002
 * @author        Antti Enqvist & Juho Yli-Honkola
 * @version 1.0
 */

public class Line extends BaseObject {
/**
* Target symbol. Line will be drawn between Target_1 and Target_2
*/
  protected Symbol Target_1;
  protected Symbol Target_2;
  Point LineHotSpot = new Point();

/**
* is this value is true then those little boxes over lines will be drawn
*/
  static boolean isShown = true;
/**
* the color of the line
*/
  static Color lineColor = Color.black;

  HotSpot t1;
  HotSpot t2;
  int laskuri=0;
  public Line() {
    t1 = new HotSpot();
    t2 = new HotSpot();

    this.addKeyListener(new java.awt.event.KeyAdapter() {
      public void keyPressd(KeyEvent e) { keyType(e);}
      });

  }

  public void SetTarget1(Symbol T_1){//,Symbol T_2){
  Target_1=T_1;
  //Target_2=T_2;

  }
  public Symbol GetTarget1(){
    return Target_1;
  }
  public Symbol GetTarget2(){
    return Target_2;
  }
  public void SetTarget2(Symbol T_2){
    Target_2=T_2;
   updateLines();


    Target_1.addComponentListener(new java.awt.event.ComponentAdapter(){
      public void componentMoved(ComponentEvent e){ updateLines() ;}
    });
    Target_1.addComponentListener(new java.awt.event.ComponentAdapter(){
      public void componentResized(ComponentEvent e){ updateLines() ;}
    });

    Target_2.addComponentListener(new java.awt.event.ComponentAdapter(){
      public void componentMoved(ComponentEvent e){ updateLines() ;}
    });
    Target_2.addComponentListener(new java.awt.event.ComponentAdapter(){
      public void componentResized(ComponentEvent e){ updateLines() ;}
    });


  }

/**
* this fuction updates the place of the line
*/

  public void updateLines(){
    if (Target_1 !=null && Target_2 !=null){
      int P_x,P_y;

      P_x = Target_1.GetMiddlePoint().x + ((Target_2.GetMiddlePoint().x -Target_1.GetMiddlePoint().x)/2);
      P_y = Target_1.GetMiddlePoint().y + ((Target_2.GetMiddlePoint().y -Target_1.GetMiddlePoint().y )/2);
      LineHotSpot.x=getX();LineHotSpot.y=getY();

      LineHotSpot.x = P_x;
      LineHotSpot.y = P_y;

//      g2 = (Graphics2D) g;      width=1;   g2.setStroke(new BasicStroke(width));

      t1 = Target_1.GetNearest(LineHotSpot);
      t2 = Target_2.GetNearest(LineHotSpot);
      this.setBounds(t1.getX() + ((t2.getX() -t1.getX()) /2),t1.getY()+((t2.getY()-t1.getY())/2),4,4);

    }
  }

/**
* this function draws line
*
*/

  public void PaintThis(Graphics g){// draw line between target1 and target2
    if(drawYourself){
      if(obj_focus)
        g.setColor(Color.red);
      else
        g.setColor(lineColor);

      g.drawLine(getX()+1,getY()+1,t1.getX(),t1.getY());
      g.drawLine(getX()+1,getY()+1,t2.getX(),t2.getY());
      if (isShown)
        g.drawRect(getX(),getY(),3,3);
      if(getFieldData(1)!=null)
        g.drawString(getFieldData(1),getX()-10,getY()-10);
    }
 }

  public void keyType(KeyEvent e){

  }
/**
* Invokes when mouse is pressed over line
*/
  public void mousePressed(MouseEvent e)
 {
    if (e.isMetaDown()== true){} //occurs when right mouse button is clicked
    else setCursor( Cursor.getPredefinedCursor(Cursor.MOVE_CURSOR));
    SetObjectFocus(true);


 }
  public void paint(Graphics g){

  }
/**
* returns line focus
*/
  public boolean getObjectFocus(){
    return obj_focus;
  }

  public void isHotSpotShown(boolean b){
    isShown = b;
  }
/**
* returns information if hotspot is drawn or not
*/
  public boolean getHotSpotStatus(){
    return isShown;
  }

/**
* set the color of the line
*/
  public void setLineColor(Color newcol){
    lineColor = newcol;
  }

/**
* Function sets object focus either true or false
*
* @param focus if this param is true then this component gets focus. If it is false
* componen loses it
*/

  public void SetObjectFocus(boolean focus){
    if (focus == obj_focus){return;}
    obj_focus = focus;
    ErkkaEvent w;
    w = new ErkkaEvent(this, ErkkaEvent.BOX_SELECTED);
    erkkaListener.Selected(w);
  }
}