package erkka;
import java.awt.event.*;
import java.awt.Color;
import java.awt.*;
import java.util.*;

import com.sun.org.apache.xalan.internal.xslt.*;

import com.sun.org.apache.xerces.internal.parsers.DOMParser;
import com.sun.org.apache.xerces.internal.*;
import org.w3c.dom.*;
import com.sun.org.apache.xerces.internal.dom.*;
import com.sun.org.apache.xml.internal.serialize.*;

import java.io.*;
import java.awt.image.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.undo.*;

/**
 * Uses a SwingWorker to perform a time-consuming task.
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Versio 1.2</p>
 * @author Erkka-projekti 2003, Jukka Mntyl 2005
 * @version 1.2 Jukka Mntyl. Muunnos omassa metodissa. Kutsut tehty.
 */

public class LongTask {
    private int lengthOfTask;
    private int current = 0;
    private String statMessage;
    private String fileName;
    private StringBuffer edit;
    private ChangeListener listener;

    LongTask(String _fileName, ChangeListener _listener) {
        fileName =  _fileName;
        edit = new StringBuffer("");
        listener = _listener;
        //Compute length of task...
        //In a real program, this would figure out
        //the number of bytes to read or whatever.
        lengthOfTask = 100;
    }

    public String getResults() {
      return edit.toString();
    }

    public void setActionListener(ChangeListener listener) {
      this.listener = listener;
    }

    /**
     * Called from ProgressBarDemo to start the task.
     */
    void go() {
        current = 0;
        final SwingWorker worker = new SwingWorker() {
            public Object construct() {
                return new ActualTask(fileName, edit);
            }
        };
        worker.start();
    }

    /**
     * Called from ProgressBarDemo to find out how much work needs
     * to be done.
     */
    int getLengthOfTask() {
        return lengthOfTask;
    }

    /**
     * Called from ProgressBarDemo to find out how much has been done.
     */
    int getCurrent() {
        return current;
    }

    void stop() {
        current = lengthOfTask;
    }

    /**
     * Called from ProgressBarDemo to find out if the task has completed.
     */
    boolean done() {
        if (current >= lengthOfTask) {
          if (listener != null) {
            listener.stateChanged(new ChangeEvent(this));
          }
          return true;
        } else
          return false;
    }

    String getMessage() {
        return statMessage;
    }

    /**
     * The actual long running task.  This runs in a SwingWorker thread.
     */
    class ActualTask {

      ActualTask (String fName, StringBuffer edit) {

        InputStream in = null;
        OutputStream out = null;

        Reader reader;
        BufferedReader breader = null;
        //current = 7;
        //edit.setFont( new Font("Courier", Font.PLAIN, 12) );
        current = 20;

        Muunnos muunnos = new Muunnos();
        muunnos.muunna(fName,"1.xsl","1.tmp");
        current += 10;
        muunnos.muunna("1.tmp","2.xsl","2.tmp");
        current += 10;
        muunnos.muunna("2.tmp", "3.xsl", "3.tmp");
        current += 10;
        muunnos.korjaanimet("3.tmp","4.tmp");
        current += 5;
        muunnos.muunna("4.tmp", "4.xsl", "5.tmp");
        current += 10;
        muunnos.muunna("5.tmp", "5.xsl", "6.tmp");
        current += 10;
        muunnos.jarjesta("6.tmp","7.tmp");
        current += 10;
        muunnos.muunna("7.tmp", "6.xsl", "tulos.sql");

        /*
        try {
          XSLTProcessor processor = XSLTProcessorFactory.getProcessor();

          in = new FileInputStream(fName);//bin\uFFFD\uFFFDrivirta lukee tiedostoa
          reader = new InputStreamReader(in, "UTF-8");
          breader = new BufferedReader(reader);

          XSLTInputSource xmlSource = new XSLTInputSource(breader);
          XSLTInputSource xslSheet = new XSLTInputSource("1.xsl");
          out = new FileOutputStream("testi.tmp"); //kirjoittaa tiedostoon
          XSLTResultTarget xmlResult = new XSLTResultTarget(out);
          processor.process(xmlSource, xslSheet, xmlResult);

          current += 13;

          in = new FileInputStream("testi.tmp");
          reader = new InputStreamReader(in, "UTF-8");
          breader = new BufferedReader(reader);
          xmlSource = new XSLTInputSource(breader);
          xslSheet = new XSLTInputSource("2.xsl");
          out = new FileOutputStream("testi2.tmp");
          xmlResult = new XSLTResultTarget(out);
          processor.process(xmlSource, xslSheet, xmlResult);
      //    File delFile= new File("testi.tmp");
      //    delFile.delete();
          current += 13;

          in = new FileInputStream("testi2.tmp");
          reader = new InputStreamReader(in, "UTF-8");
          breader = new BufferedReader(reader);
          xmlSource = new XSLTInputSource(breader);
          xslSheet = new XSLTInputSource("3.xsl");
          out = new FileOutputStream("testi3.tmp");
          xmlResult = new XSLTResultTarget(out);
          processor.process(xmlSource, xslSheet, xmlResult);
       //   delFile= new File("testi2.tmp");
       //   delFile.delete();
          current += 13;

          in = new FileInputStream("testi3.tmp");
          reader = new InputStreamReader(in, "UTF-8");
          breader = new BufferedReader(reader);
          xmlSource = new XSLTInputSource(breader);
          xslSheet = new XSLTInputSource("4.xsl");
          out = new FileOutputStream("testi4.tmp");
          xmlResult = new XSLTResultTarget(out);
          processor.process(xmlSource, xslSheet, xmlResult);
       //   delFile= new File("testi3.tmp");
       //   delFile.delete();
          current += 13;

          in = new FileInputStream("testi4.tmp");
          reader = new InputStreamReader(in, "UTF-8");
          breader = new BufferedReader(reader);
          xmlSource = new XSLTInputSource(breader);
          xslSheet = new XSLTInputSource("5.xsl");
          out = new FileOutputStream("testi5.tmp");
          xmlResult = new XSLTResultTarget(out);
          processor.process(xmlSource, xslSheet, xmlResult);

     //     delFile= new File("testi4.tmp");
     //     delFile.delete();
          current += 13;

          in = new FileInputStream("testi5.tmp");

          reader = new InputStreamReader(in, "UTF-8");
          breader = new BufferedReader(reader);
          xmlSource = new XSLTInputSource(breader);
          xslSheet = new XSLTInputSource("6.xsl");
          out = new FileOutputStream("tulos.sql");
          xmlResult = new XSLTResultTarget(out);
          processor.process(xmlSource, xslSheet, xmlResult);
          out.close();
        //  delFile= new File("c:\\mytemp\\uusi_erkka\\Erkka\\testi5.tmp");
        //  delFile.delete();
        //  delFile.deleteOnExit();
        }
        catch (org.apache.xalan.xslt.XSLProcessorException e) {
         //< KKL
          MessageBox msg = new MessageBox();
          msg.setTitle("Error in processing sql transformation");
          msg.askOkay(e.getLocalizedMessage());
          //> KKL
          //e.printStackTrace();
        }
        catch (Exception e) {
          e.printStackTrace();
        }
        */

        breader=null;
        try {
          in = new FileInputStream("tulos.sql");
          reader = new InputStreamReader(in,"UTF-8");
          breader = new BufferedReader(reader);
          String line;
          current += 10;
          while ( (line=breader.readLine())!= null) {
            edit.append(line);
            edit.append('\n');
          }
          /*
          if (edit.length() < 6) {
            edit.delete(0,edit.length());
            edit.append("-- Error");
          } */
        } catch ( IOException ioe ) {
          ioe.printStackTrace();
        } finally {
        try {
          if (breader != null) breader.close();
        } catch (IOException ioe) {
            ioe.printStackTrace();
        }

        current = 100;
      }

    }
            //Fake a long task,
            //making a random amount of progress every second.
     /*       while (current < lengthOfTask) {
                try {
                    Thread.sleep(1000); //sleep for a second
                    current += Math.random() * 100; //make some progress
                    if (current > lengthOfTask) {
                        current = lengthOfTask;
                    }
                    statMessage = "Completed " + current +
                                  " out of " + lengthOfTask + ".";
                } catch (InterruptedException e) {}
            }
        }*/
    }
}
