package erkka;

import javax.swing.UIManager;
import java.awt.*;

/**
 * Title:        Erkka-Projekti
 * Description:  Simple drawing program and sql-generator. Easy to add new
 * symbols, just edit config file and write new paint methods Symbol class.
 * Copyright:    Copyright (c) 2002
 * Company:      Erkka
 * @author Antti Enqvist & Tommi Grenfors & Hanna-Leena Peltomaa& Juho Yli-Honkola
 * @version 1.22 Fixed problem with renamed org.apache -packages.
 * @version 1.2 Jukka Mntyl 2005. SQL-panel no more.
 * @version 1.11 Jukka Mntyl 2005. Fixed fatal bug in opening erkka-files.
 * @version 1.1 Jukka Mntyl 2005. Changelist:
 * - java 1.5 compability => uses xalan 2.6, changed Muunnos.java, LongTask.java
 * - checks if there are problems with ER-diagram before transforming to SQL. ODBCConnect
 * - XSL-fixes: params. XSL-files.
 * - NUMERIC(*,*) now accepted in relation-view. Relation.java
 * - fixed stall when selecting view | sql. Control.java
 * - Query-panel. MainWindow.java. Control.java.
 * @version 1.0
 */

public class Main {
  boolean packFrame = false;

  /**Construct the application*/
  public Main() {
    MainWindow frame = new MainWindow();

    //Validate frames that have preset sizes
    //Pack frames that have useful preferred size info, e.g. from their layout
    if (packFrame) {
      frame.pack();
    }
    else {
      frame.validate();
    }
    //Center the window
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frame.getSize();
    if (frameSize.height > screenSize.height) {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width) {
      frameSize.width = screenSize.width;
    }
    frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);



    frame.setVisible(true);
  }
  /**Main method*/
  public static void main(String[] args) {
    try {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
      new Main();
    }
    catch(Exception e) {
    //< KKL
      MessageBox msg = new MessageBox();
      msg.setTitle("Unhandled exception");
      msg.askOkay(e.getLocalizedMessage());
    //> KKL
      e.printStackTrace();
    }

  }
}
