package erkka;
import java.io.*;
import javax.xml.transform.*;
import javax.xml.transform.stream.*;
import javax.xml.parsers.*;
import com.sun.org.apache.xml.internal.serialize.*;
import com.sun.org.apache.xpath.internal.XPathAPI;
import org.w3c.dom.*;
import java.util.Vector;
import java.util.Iterator;

//import org.apache.xalan.xslt.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * <p>Versio 1.2</p>
 * @author Erkka-projekti 2003, Jukka Mntyl 2005
 * @version 1.2 Jukka Mntyl: Xalan 2.6 yhteensopivuus. Viety muunnos yhteen funktioon.
 */

public class Muunnos {

  private TransformerFactory tFactory;

  public Muunnos() {
     tFactory = TransformerFactory.newInstance();
  }

  /**
   * Numeroi samannimisten taulujen nimet ja kaikki SQL:ss nkymttmt 1-M-relaatiot
   * @param inFile sytettv xml-tiedosto
   * @param outFile tulostiedoston nimi
   * @todo: nimikorjailuja tehdn kahdessa paikkaa. Pitisk olla komponentti johon saa sytt vain oikeaa?
   */
  public void korjaanimet(String inFile, String outFile) {
    DocumentBuilderFactory dfactory = DocumentBuilderFactory.newInstance();
    try {
      // parsitaan xml-dokumentti jrjestely varten
      DocumentBuilder dbuilder = dfactory.newDocumentBuilder();
      Document doc = dbuilder.parse(inFile);
      ///descendant::node()[count(child::Skip) > 2] /descendant::mchoice[count(child::answer)>4]
      NodeList names = XPathAPI.selectNodeList(doc.getDocumentElement(),"child::*[self::entity or self::relation[count(descendant::link[contains(text(),'M')]) > 1]]/name");
      Node n;
      int i,j;
      int numero = 2;

      // erotetaan samannimiset taulut numerolla
      for (i=0;i<names.getLength();i++) {
        for (j=i+1;j<names.getLength();j++) {
          n = names.item(j).getFirstChild();
          if (names.item(i).getFirstChild().getNodeValue().equals(n.getNodeValue())) {
            n.setNodeValue(n.getNodeValue() + numero);
            numero++;
          }
        }
      }
      // numeroidaan kaikki 1-M-relaatiot, etteivt ne sotkeudu muunnoksissa todellisiin tauluihin
      names = XPathAPI.selectNodeList(doc.getDocumentElement(),"child::relation[count(descendant::link[contains(text(),'1')]) > 0]/name");
      for (i=0;i<names.getLength();i++) {
        n = names.item(i).getFirstChild();
        n.setNodeValue(n.getNodeValue() + numero);
        numero++;
      }

      XMLSerializer serializer = new XMLSerializer();
      serializer.setOutputFormat(new OutputFormat("XML", "UTF-8", true));
      serializer.setOutputCharStream(new FileWriter(outFile));
      serializer.serialize(doc);

    } catch (Exception e) {
      MessageBox msg = new MessageBox();
      msg.setTitle("Error in processing sql transformation.");
      msg.askOkay(e.getLocalizedMessage());
    }
  }

  /*
    ongelma: lopussa sql:t tulevat vrn jrjestykseen

    0. ksitelln sql-muunnoksen toisiksi viimeist, xml-muotoista tietoa
    1. etsitn tauluja joissa ei ole viitteit muihin, listn Listaan
    2. otetaan lopuista sellaiset taulut jotka viittavat vain Listassa oleviin
       - jos ei lydy sellaisia niin otetaan loppujoukossa arvalla jokin
         jossa on mahdollisimman vhn viittauksia, tllin tilanne on
         sellainen ettei sit pysty purkamaan muutakuin sopivalla transaktiolla
    3. jatketaan kohdasta 2 kunnes kaikki kohteet on kyty lpi
    4. listn M-M-suhteet
  */
 /**
  * Jrjest toisiksi viimeisen vaiheen XML-tiedoston nodet sellaiseen jrjestykseen,
  * ett ne voidaan ajaa suoraan tietokantaan
  * @param inFile toisiksi viimeisen vaiheen XML-tiedosto
  * @param outFile viimeisen vaiheen XML-tiedoston nimi
  */
 public void jarjesta(String inFile, String outFile) {
    DocumentBuilderFactory dfactory = DocumentBuilderFactory.newInstance();
    try {
      // parsitaan xml-dokumentti jrjestely varten
      DocumentBuilder dbuilder = dfactory.newDocumentBuilder();
      Document doc = dbuilder.parse(inFile);
      Element root = doc.createElement("all");


      // kertn suhdetaulut
      NodeList relationentities = XPathAPI.selectNodeList(doc.getDocumentElement(),"Relationentity");
      NodeList ref, sorted;
      int i,j,k;

      // etsitn ne joissa ei ole referenssej muihin tauluihin
      NodeList entities = XPathAPI.selectNodeList(doc.getDocumentElement(),"entity[not(ref/attrib/tablename)]");
      //  ref = XPathAPI.selectNodeList(entities.item(i),"./ref/attrib/tablename/text()");
      for (i=0;i<entities.getLength();i++) {

       // if (ref.getLength() == 0) {
          root.appendChild(entities.item(i));
       // }
      }

      // jos ei lytynyt yhtn niin listn joku, jossa on vhn referenssej
      // tllin tietokannan luominen ei onnistu muutenkaan ilman erityistoimenpiteit
      // (viittausympyr)
      Node leastref = null;
      if (!root.hasChildNodes()) {
        int minrefcount = Integer.MAX_VALUE;
        for (i=0;i<entities.getLength();i++) {
          ref = XPathAPI.selectNodeList(entities.item(i),"./ref/attrib/tablename/text()");
          if (ref.getLength() < minrefcount) {
            leastref = entities.item(i);
            minrefcount = ref.getLength();
          }
        }
        if (leastref != null)
          root.appendChild(leastref);
      }


      // etsitn ne, jotka vain viittaavat edellisiin ja listn ne joukkoon
      entities = XPathAPI.selectNodeList(doc.getDocumentElement(),"entity[ref/attrib/tablename]");
      Vector refentities = new Vector();
      for (i = 0; i < entities.getLength(); i++)
        refentities.add(entities.item(i));
      boolean found;
      int sortedcount = 0;
      Node currentnode;
      while (refentities.size() > 0) {
        sortedcount = root.getChildNodes().getLength();
        Iterator ite = refentities.iterator();
        while (ite.hasNext()) {
          currentnode = (Node)ite.next();
          sorted = XPathAPI.selectNodeList(root, "entity/name/text()");
          ref = XPathAPI.selectNodeList(currentnode,
                                        "./ref/attrib/tablename/text()");
          found = false;
          // jokaista viitett kohden on tarkistettava lytyyk ko. kohdetta
          // nykyisist, jrjestetyist tauluista
          for (j = 0; j < ref.getLength(); j++) {
            found = false;
            for (k = 0; k < sorted.getLength(); k++) {
              if (ref.item(j).getNodeValue().equals(sorted.item(k).getNodeValue())) {
                found = true;
                break;
              }
            }
            if (!found) break;
          }
          if (found) {
            root.appendChild(currentnode);
            ite.remove();
          }

          }

          // jos taulujen mr ei ole lisntynyt niin on lytynyt toinen
          // viittausympyr. Tllin listn summissa sellainen taulu
          // jossa on mahdollisimman paljon viittauksia jrjestettyihin tauluihin,
          // mutta vhn muihin
          if (sortedcount >= root.getChildNodes().getLength()) {
            Node goodentity = null;
            int goodrefcount = 0, bestrefcount = Integer.MIN_VALUE;
            sorted = XPathAPI.selectNodeList(root, "entity/name/text()");
            ite = refentities.iterator();
            while (ite.hasNext()) {
              goodrefcount = 0;
              currentnode = (Node)ite.next();
              ref = XPathAPI.selectNodeList(currentnode,"./ref/attrib/tablename/text()");
              found = true;
              for (j = 0; j < ref.getLength(); j++) {
                for (k = 0; k < sorted.getLength(); k++) {
                  if (ref.item(j).getNodeValue().equals(sorted.item(k).getNodeValue()))
                    goodrefcount++;
                  else
                    goodrefcount--; // jos lytyy muita niin nm vhentvt hyvi viitteit
                }
              }
              if (goodrefcount > bestrefcount) {
                goodentity = currentnode;
                bestrefcount = goodrefcount;
              }
            }
            if (goodentity != null)
              root.appendChild(goodentity);
        }

      }

      // listn relationentityt puuhun
      for (i=0;i<relationentities.getLength();i++) {
        root.appendChild(relationentities.item(i));
      }

      // vaihdetaan vanha jrjestmtn all-elementti uuteen
      doc.replaceChild(root,doc.getDocumentElement());

      // muunnetaan dom-puu tekstiksi ja trktn ulos
      XMLSerializer serializer = new XMLSerializer();
      serializer.setOutputFormat(new OutputFormat("XML","UTF-8",true));
      serializer.setOutputCharStream(new FileWriter(outFile));
      serializer.serialize(doc);

    } catch (Exception e) {
      MessageBox msg = new MessageBox();
      msg.setTitle("Error in processing sql transformation.");
      msg.askOkay(e.getLocalizedMessage());
    }
      /*
    } catch (org.xml.sax.SAXException e) {
      // DocumentBuilder: parse error.
    } catch (ParserConfigurationException e) {
      // DocumentBuilder: configuration error.
    }
    */



  }

  public void muunna(String inFile, String xslFile, String outFile) {

    try {
      InputStream in = new FileInputStream(inFile); //bin\uFFFD\uFFFDrivirta lukee tiedostoa
      Reader reader = new InputStreamReader(in, "UTF-8");
//      breader = new BufferedReader(reader);
      StreamSource source = new StreamSource(reader);

      Source xsl = new StreamSource(xslFile);
      Transformer processor = tFactory.newTransformer(xsl);

      OutputStream out = new FileOutputStream(outFile); //kirjoittaa tiedostoon
      StreamResult result = new StreamResult(out);

      processor.transform(source, result);
      in.close();
      out.close();

    }
    catch (javax.xml.transform.TransformerException e) {
      MessageBox msg = new MessageBox();
      msg.setTitle("Error in processing SQL transformation");
      msg.askOkay(e.getLocalizedMessage());
    }
    catch (Exception e) {
      e.printStackTrace();
    }


  }

}
