package erkka;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.ChangeListener;



/**
 * <p>Title: Erkka-Projekti</p>
 * <p>Description: Progress bar</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Erkka</p>
 * @author Antti Enqvist & Juho Yli-Honkola
 * @version 1.0
 */

public class ProgresWaitDialog extends JFrame {
    public final static int ONE_SECOND = 1000;

    private JProgressBar progressBar;
    private Timer timer;
    private LongTask task;
    private String newline = "\n";
    private String fileName;
    private StringBuffer edit;
    private ChangeListener listener;

/**
* Default constructor creates Progressbar
*/
    public ProgresWaitDialog() {
        super("Transforming...");

        //Create the demo's UI.

        progressBar = new JProgressBar(0, 100 );
        progressBar.setValue(0);
        progressBar.setStringPainted(true);

        JPanel panel = new JPanel();
        panel.add(progressBar);

        JPanel contentPane = new JPanel();
        contentPane.setLayout(new BorderLayout());
        contentPane.add(panel, BorderLayout.NORTH);
        contentPane.setBorder(BorderFactory.createEmptyBorder(20, 20, 20, 20));
        setContentPane(contentPane);

        centerWindow();

        //Create a timer.
        timer = new Timer( 100, new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                progressBar.setValue(task.getCurrent());
                if (task.done()) {
                    Toolkit.getDefaultToolkit().beep();
                    timer.stop();
                    setVisible(false);
                }
            }
        });
    }


    public void doTransformation(String _fileName) {
      progressBar.setValue(0);
      setVisible(true);
      task = new LongTask(_fileName, listener);
      timer.start();
      task.go();
    }

    // asettaa listenerin, joka kuuntelee kun longtask saadaan suoritetuksi
    public void setStateChangeListener(ChangeListener l) {
      listener = l;
    }


    private void centerWindow() {
      Dimension screenDim = Toolkit.getDefaultToolkit().getScreenSize();
      // If larger than screen, reduce window width or height
      if (screenDim.width < getSize().width) {
          setSize(screenDim.width, getSize().height);
      }
      if (screenDim.height < getSize().height) {
          setSize(getSize().width, screenDim.height);
      }
      // Center Frame, Dialogue or Window on screen
      int x = (screenDim.width - getSize().width) / 2;
      int y = (screenDim.height - getSize().height) / 2;
      setLocation(x, y);
}

}
