package erkka;
import javax.swing.*;
import java.awt.*;
import java.util.*;
import java.awt.event.*;
import java.io.*;
import java.util.Hashtable;
/**
 * <p>Title: </p>
 * <p>Description: This class handles relation view. </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author Antti Enqvist & Hanna-Leena Peltomaa &Juho Yli-Honkola
 * @version 1.0
 */

public class RelDrawingPanel extends JPanel {
/**The marginal in the top and left edge */
  int marginal = 10;
/**The space between boxes */
  int spaceBetweenBoxes = 200;
/**Drawingpanel */
  DrawingArea panel;
/***/
 Hashtable box_coordinates = new Hashtable();
/**
 * constructor creates new SimpleFrame
 */
  public RelDrawingPanel() {}

/**
 * <p>main program
 * New Relations are created and its information are read from a file
 * All <code>CREATE TABLE</code>s are drown and then lines</p>
 * @param args
 */

  public void drawRelation(String fileName) {

    if (panel!=null){
      this.removeAll();
      panel=null;
    }
    Relations relations = new Relations();

    relations.readFile(fileName);

    panel = new DrawingArea();
    this.add(panel);
    panel.setBounds(0,0,getWidth(),getHeight());
    panel.setBackground(Color.white);
//    this.setBackground(Color.red);
    panel.setPreferredSize( new Dimension(getWidth(),getHeight()) );

    JScrollPane scrollPane = new JScrollPane(panel);//adding scroll
    this.add(scrollPane);

    panel.setLayout(null);

    RelationControl rc = new RelationControl(panel, box_coordinates);

    Enumeration e;
    Hashtable tables = new Hashtable();
    int i = 0, j=0;
    RelationBox box = null;
    Relation rel;

    //creating boxes for all of the createtables
    for ( e = relations.getCreateTables().elements(); e.hasMoreElements(); ) {
      rel = (Relation)e.nextElement();
      int x=j*this.spaceBetweenBoxes+this.marginal;
      int y=i*this.spaceBetweenBoxes+this.marginal;
      box = new RelationBox( rel );
      panel.AddObj(box, x,y); //coordinates in the picture

      if (box_coordinates.containsKey(box.getName())) {
        Point p = (Point)box_coordinates.get(box.getName());
        x = p.x;
        y = p.y;
        box.setBounds(x,y,70,50);
      }
      else {
        box.setBounds(x,y,70,50);
        box_coordinates.put(box.getName(), new Point(x,y));

      }
      rc.setListeners( box );
      tables.put( box.getName(), box );
      // placing boxes to the picture
      if (j<3)//four relBox are drown at the same line
        j++;
      else
      {
        i++;  //then change the line
        j=0;
      }

    }
    //creating lines between boxes
    for ( e = relations.getCreateTables().elements(); e.hasMoreElements(); ) {
      rel = (Relation)e.nextElement();
      Vector lines = rel.getLines();
      //lines of the box
      for (i=0; i<lines.size(); i++) {
        Reference ref = (Reference)lines.get(i);
        RelLine line = new RelLine(ref.getTarget1Attribute(), ref.getTarget2Attribute() );

        //tables, where the line begins(src) and where ends(dst)
        RelationBox src = (RelationBox)(tables.get(rel.getTableName()));
        RelationBox dst = (RelationBox)(tables.get(ref.getTableTarget2()));

        if ( src != null && dst != null)
        {
//          System.out.println("Adding link");
          line.SetTarget1( src );
          line.SetTarget2( dst );
          line.setInfo( ref.getCascade() );
        }
        panel.AddObj(line, 0, 0);
        line.updateLines();
//        rc.setListeners( line );
      }
      i++;
      panel.repaint();
    }
    panel.selectAll();
    panel.setPreferredSize( new Dimension( panel.getFocusTableRight()+100,
                             panel.getFocusTableBottom()+100) );
    panel.revalidate();
    panel.setFocusVectorNull();
    panel.repaint();
  }

  DrawingArea getDrawingArea() {
    return panel;
  }

/*  public void export(String fileName){
    panel.repaint();
    panel.setFocusVectorNull();
    Image i = panel.createImage(panel.getWidth(),panel.getHeight());
    panel.revalidate();
    panel.paint(i.getGraphics());
    try {FileOutputStream fileOut = new FileOutputStream( fileName );
    PNGEncoder encoder = new PNGEncoder( i, fileOut );
    try {encoder.encodeImage();
    }

    catch (PNGException e){}
    fileOut.close();

    } catch (Exception e){}

  }*/
}