package erkka;

import javax.swing.JComponent;
import java.awt.*;
import java.util.*;
import java.awt.event.*;

/**
 * <p>Title: </p>
 * <p>Description: Connect relations and paint M or 1 to line. </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author HLP
 * @version 1.0
 */

public class RelLine extends Line {
  /**The attribute of the table, who has a reference to another table */
  String startAttribute = null;
  /**Attribute of the table to whice is referenced*/
  String endAttribute = null;
  /**Information of cascades*/
  String infoText = null;
  /**Fixing lines y-coordinate*/
  int yfix = 5;

/**
 * constructor of RelLine creates new RelLine, whice is inherited from Line
 * @param startAttribute
 * @param endAttribute
 */
  public RelLine(String startAttribute, String endAttribute) {
    super();
    this.startAttribute = startAttribute;
    this.endAttribute = endAttribute;
  }
/**
 * updates lines
 */
  public void updateLines(){
    if (Target_1 !=null && Target_2 !=null){
      int P_x,P_y;

      P_x = Target_1.GetMiddlePoint().x + ((Target_2.GetMiddlePoint().x -Target_1.GetMiddlePoint().x)/2);
      P_y = Target_1.GetMiddlePoint().y + ((Target_2.GetMiddlePoint().y -Target_1.GetMiddlePoint().y )/2);
      LineHotSpot.x=getX();LineHotSpot.y=getY();

      LineHotSpot.x = P_x;
      LineHotSpot.y = P_y;

      if ( Target_1 instanceof RelationBox && Target_2 instanceof RelationBox )
      {
        RelationBox r1, r2;

        r1 = (RelationBox)Target_1;
        r2 = (RelationBox)Target_2;
        t1 = r1.GetNearest(LineHotSpot, startAttribute );
        t2 = r2.GetNearest(LineHotSpot, endAttribute );
      }
      else {
         t1 = Target_1.GetNearest(LineHotSpot);
         t2 = Target_2.GetNearest(LineHotSpot);
      }
      this.setBounds(t1.getX() + ((t2.getX() -t1.getX()) /2),t1.getY()+((t2.getY()-t1.getY())/2),4,4);

    }
  }
/**
 * draw line between target1 and target2
 * @param g
 */
  public void PaintThis(Graphics g){

    Graphics2D g2 = (Graphics2D)g;

    // Turn on antializing
    g2.setRenderingHint( RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);

    g2.setColor(lineColor);

    // Set a little thicker line style because it looks better
    g2.setStroke(new BasicStroke(1.0f));

    // Draw lines from connected objects to our "hotspot"
    g2.drawLine(getX()+1,getY()+1+yfix,t1.getX(),t1.getY()+yfix);
    g2.drawLine(getX()+1,getY()+1+yfix,t2.getX(),t2.getY()+yfix);

    // Check if we are conneted between to RelationBoxes
    if ( Target_1 instanceof RelationBox && Target_2 instanceof RelationBox )
    {
        RelationBox r1, r2;

        r1 = (RelationBox)Target_1;
        r2 = (RelationBox)Target_2;

        // TODO: Figure out the width of printed letter
        // TODO: Specify another font for 'M' and '1'

        int xfix = r1.getVerticalSpace(t1.getX());

        //g.setColor(Color.blue);
        if (t1.getX() < r1.getX() )
        { // The right side
          g2.drawLine(t1.getX()+xfix,t1.getY()+yfix,t1.getX(),t1.getY()+yfix);
          g2.drawString("M", t1.getX()+xfix-10, t1.getY()-5);
        }
        else
        { // The left side
          g2.drawLine(t1.getX()+xfix,t1.getY()+yfix,t1.getX(),t1.getY()+yfix);
          g2.drawString("M", t1.getX()+xfix+5, t1.getY()-5);
        }

        //g.setColor(Color.red);
        xfix = r2.getVerticalSpace(t2.getX());

        if (t2.getX() < r2.getX() )
        { // The right side
          g2.drawLine(t2.getX()+xfix,t2.getY()+yfix,t2.getX(),t2.getY()+yfix);
          g2.drawString("1", t2.getX()+xfix-10, t2.getY()-5);
        }
        else
        { // The left side
          g2.drawLine(t2.getX()+xfix ,t2.getY()+yfix,t2.getX(),t2.getY()+yfix);
          g2.drawString("1", t2.getX()+xfix+5, t2.getY()-5);
        }
    }
//    if (isShown)
      g2.drawRect(getX(),getY()+yfix,3,3);
  }
/**
 * cascade added to ToolTipText
 * @param infoStr lines cascade
 */
  void setInfo( String infoStr ) {
    infoText = infoStr;
    this.setToolTipText(infoText );
  }
}