package erkka;
import java.util.*;
/**
 * <p>Title: Erkka-Projekti</p>
 * <p>Description: Defines how objects can join together</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Erkka</p>
 * @author unascribed
 * @version 1.0
 */

public class Rules {
  Vector ruleTable=new Vector();
  Vector lines;
  public Rules(Vector Lines) {
    lines = Lines;

}
/**
* This function checks if two objects can join together. If true is return then these object can
*join and if false then objects can't join together
*/

  public boolean canJoin(Symbol target1,Symbol target2 ){
    String sName=target1.getFieldData(0);
    String fName=target2.getFieldData(0);
    int sId=target1.GetID();
    int fId=target2.GetID();
    if(isJoinOK(sName,sId,fName) && isJoinOK(fName,fId,sName)){
    return true;
    }


    return false;
  }
/**
* this function checks if object can join together.
*/

  public boolean isJoinOK(String c1,int c1Id,String c2){
    boolean r=false;
    for(int i=0;i<ruleTable.size();i++){
      Rule rule =(Rule)ruleTable.get(i);
      if(rule.getSName().equalsIgnoreCase(c1)&& rule.getFName().equalsIgnoreCase(c2)){
        if(rule.getMax()>checkConnectionCount(c1,c1Id))
          r=true;
      }

    }
   return r;
  }
/**
* this function checks how many object have already joined to desired component
* it returns counter which include how many objects have joined desired component
*/
  public int checkConnectionCount(String sName,int sId){
    int counter=0;
    for(int i=0;i<lines.size();i++){
      Line l=(Line)lines.get(i);
      if(l.GetTarget1().GetID()==sId || l.GetTarget2().GetID()==sId)
        counter++;

    }
    return counter;
  }

/**
* This function adds new rule how two objects can join together
*/
  public void addNewRule(String sName,String friendName,String max){

  int count=9999;
  if( !max.equals("*")) // if max value is '*' then there is no limit
    count=Integer.parseInt(max);

   Rule r =new Rule(sName,friendName,count);
   ruleTable.add(r);
  }
}