package erkka;

import java.util.*;
import javax.swing.*;
import java.awt.Dimension;
import java.awt.Color;
/**
 * Title:        Erkka-Projekti
 * Description:  This class handle symbols data and generates new symbols with
 * default values. Init factory addSymbol-method later yuo can call
 * createSymbol-method.
 * Copyright:    Copyright (c) 2002
 * @author      Juho Yli-Honkola
 * @version 1.2 getExtraProper, getSelectionType - Jukka Mntyl 2005
 */

public class SymbolFactory {

  Hashtable SymbolAndFields =new Hashtable();
  Vector  Selections=new Vector();
  String containerName;
  String contaisType;

  public SymbolFactory() {

  }
/**
 *
 * @param objName Symbol name
 * @param fName Field name
 * @param fDValue Field data
 * @param select  Selectionbox name
 */
  public void initSymbolFields(String objName,String fName,String fDValue,String select){
  if (fDValue == null) fDValue = " ";
    try{
    if(!SymbolAndFields.containsKey(objName)){
      throw new Exception();
    }
    else
      ((BaseObject)SymbolAndFields.get(objName)).setNewField(fName, fDValue,select);
    } catch (Exception e){e.printStackTrace();}

  }
/**
 * Tells if Symbol is container
 * @param symbolName
 * @return What kind of symbol container can contains, if not container, ret null.
 */
  public String isContainer(String symbolName){
    if(symbolName==null)
      return null;

    if(symbolName.equalsIgnoreCase(containerName))
      return contaisType;
    return null;
  }
/**
 * Add new symbol in hashtable. You need to call this method right name before
 * can call createSymbol method.
 * @param Name    Symbol name.
 * @param Cname   Class name(type in config file).
 * @param Height  Default height for symbol.
 * @param Width   Default width dor symbol.
 * @param OColor  Color for Symbol.
 * @param contains What symbol can contain.
 */
  public void addNewSymbol(String Name, String Cname, String Height, String Width, String OColor,String contains){
  int objHeight, objWidth;
  if(contains !=null && contains.length()>1){
    contaisType=contains;
    containerName=Name;
  }
  try {
    objHeight = Integer.parseInt(Height);
    objWidth = Integer.parseInt(Width);
  } catch(Exception e){objHeight = 40; objWidth=60;}
  // construct symbol and put it in hastable.
  BaseObject Symb = new BaseObject();
  Symb.setBounds(0,0,objWidth, objHeight);
  Symb.setSize(objWidth,objHeight);

  SymbolAndFields.put(Name,Symb);
// save in first field Symbol class and name.
  Symb.setNewField(Cname,Name, " ");
  try{
  Symb.setObjectColor(Color.decode(OColor));
  }
  catch(Exception  ex){; }// do nothing, symbol use default color =(Black)

  }
/**
 * Create symbol and init it defaut values.
 * @param objectName Name to find right class.
 * @return
 */
  public BaseObject createSymbol(String objectName){
    String ClassName;
    BaseObject temp=new BaseObject();
    if(objectName==null)
      return null;
    if(objectName.length()<=1)
      return null;
    Class s;
    BaseObject tempSymbol, tSymbol;

    if(SymbolAndFields.containsKey(objectName)){;
    //objectName= objectName.toLowerCase();
       try{
        ClassName=((BaseObject)SymbolAndFields.get(objectName)).getFieldName(0);
        s = (Class.forName("erkka."+ ClassName));
        temp=(BaseObject)s.newInstance();
        //((Symbol)temp).SetProperties("Antti",0);

       }catch(Exception ex) {ex.printStackTrace();};
    // init symbol default values
      tempSymbol= (BaseObject)temp;
      tSymbol=(BaseObject)SymbolAndFields.get(objectName);
      tempSymbol.setBounds(1,1,tSymbol.getWidth(),tSymbol.getHeight());
      tempSymbol.setObjectColor(tSymbol.color);
      tempSymbol.setMinimumSize(new Dimension(tSymbol.getWidth(),tSymbol.getHeight()));
      for(int i=0;i<tSymbol.getFieldsCount();i++){
        tempSymbol.setNewField(tSymbol.getFieldName(i),tSymbol.getFieldData(i),tSymbol.getFieldDataType(i));
      }
    }
    else{// if symbol not in hashtable, try direct for parameter.
      try{
      s = (Class.forName("erkka."+ objectName));
      temp=(BaseObject)s.newInstance();

      }
      catch (Exception error){error.printStackTrace();}
    return temp;
    }
    return tempSymbol;
  }

  public int getSymbolsCount(){
   return SymbolAndFields.size();
  }

  public Enumeration getSymbols(){
    return SymbolAndFields.elements();
  }

/**
 * Add new selection
 * @param name Selection name
 * @param type Selection type( combo or checkbox).
 */
  public void addNewSelectionBox(String name,String type){// combobox or checkbox
    SelectionBox sb=new SelectionBox(name,type);
    Selections.add(sb);

  }
/**
 * Add choise in selection box, add info for possibly extradata field.
 * @param oName     Selection name.
 * @param choiceName Choice name(user see this text)
 * @param fName     Extra field name
 * @param fDefault  Extra field default
 */
  public void addChoiceInSelection(String oName,String choiceName,String fName,String fDefault){
    Proper p=null;
    if(fName!=null){
      p=new Proper(fName);
      p.setPData(fDefault);
    }

    for(int i=0;i<Selections.size();i++){
      SelectionBox sele=(SelectionBox)Selections.get(i);
      if(sele.getName()==oName)
        sele.addChoice(choiceName,p);
    }
  }
/**
 * Create selectionbox(Combo or check box)
 * @param type
 * @return box
 */
  public JComponent createSelection(String type){
    SelectionBox sele;
    JComboBox cBox=new JComboBox();
  // Find selection and init it
    for(int i=0;i<Selections.size();i++){
      sele=(SelectionBox) Selections.get(i);
      if(sele.getName().equalsIgnoreCase(type)){
        if(sele.getTypeName().equalsIgnoreCase("checkbox"))
          return new JCheckBox(" ");
        for(int j=0;j<sele.getChoiceCount();j++)
          cBox.addItem(sele.getChoiceName(j));
        return cBox;

      }
    }
    return new JCheckBox("error");
  }
/**
 * Returns extrafield if exist.
 * @param text Choice field name.
 * @return
 */
  public Proper getChoiceProper(String text){
    SelectionBox sele;

    for(int i=0;i<Selections.size();i++){
      sele=(SelectionBox) Selections.get(i);
      if(sele.getExtrafield(text)!=null)
        return sele.getExtrafield(text);

    }
    return null;
  }

  // jm: etsii extrakentn selectionboxin nimen (esim. datatypes) ja
  // kentn nimen (esim. length) perusteella ja palauttaa proper(tyn)
  /**
   * Etsii extrakentn
   * @param selectionboxname nimi (esim. datatypes)
   * @param extrafieldname kentn nimi (esim. length)
   * @return Proper -extrakentt
   */
  public Proper getExtraProper(String selectionboxname, String extrafieldname) {
    SelectionBox sele;

    for (int i = 0; i < Selections.size(); i++) {
      sele = (SelectionBox) Selections.get(i);
      if (sele.getName().equals(selectionboxname))
        return sele.getExtrafieldByName(extrafieldname);
    }
    return null;
  }

  // antaa tietyll namella olevan selection-boxin tyypin
  /**
   * Etsii selectionboxin tyypin
   * @param selectionboxname String name
   * @return String Selection-boxin tyyppi
   */
  public String getSelectionType(String selectionboxname) {
    SelectionBox sele;

    for (int i = 0; i < Selections.size(); i++) {
      sele = (SelectionBox) Selections.get(i);
      if (sele.getName().equals(selectionboxname))
        return sele.getTypeName();
    }
    return "";

  }

}
