<?xml version="1.0" encoding="UTF-8"?>
<!--
  changed by Tommi Lahtonen 28.11.2003
	Fixed a new bug in composite primary key generation (thanks to Demak for finding this)

	changed by Tommi Lahtonen 25.11.2003
	Added newline before ;
  Added DROP TABLE

  changed by Tommi Lahtonen 5.11.2003
  Fixed a bug in composite primary key generation
	changed the order of the CREATE TABLE clauses a little bit smarter

  changed by Jukka Mäntylä 28.2.2005
     Primary key code
     Old primary key code:
	PRIMARY KEY (<xsl:for-each select="attri"><xsl:if test="primary=not(empty)"><xsl:value-of select="name"/></xsl:if></xsl:for-each>)<xsl:for-each select="ref/attrib">,

  changed by Jukka Mäntylä 7.4.2005
     tables are ordered using Muunnos.java jarjesta-method
     DROP TABLEs are now in descending order

  changed by Jukka Mäntylä 8.4.2005
     added tablename in front of referenced attribute name in M-to-1-tables

  changed by Jukka Mäntylä 9.4.2005
     table refers now properly to table with composite primary key

-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="html"/>
<!-- This xsl-file gives SQL with last xml-file (5.xsl product)-->
<xsl:template match="/">
<!--
<xsl:for-each select="all/Relationentity[ref/attrib]">
DROP TABLE <xsl:value-of select="name"/>
;
</xsl:for-each>
<xsl:for-each select="all/entity[ref/attrib]">
DROP TABLE <xsl:value-of select="name"/>
;
</xsl:for-each>
<xsl:for-each select="all/Relationentity[not(ref/attrib)]">
DROP TABLE <xsl:value-of select="name"/>
;
</xsl:for-each>
<xsl:for-each select="all/entity[not(ref/attrib)]">
DROP TABLE <xsl:value-of select="name"/>
;
</xsl:for-each>
-->

<xsl:for-each select="all/Relationentity">
<xsl:sort order="descending" select="position()"/>
DROP TABLE <xsl:value-of select="name"/>
;
</xsl:for-each>
<xsl:for-each select="all/entity">
<xsl:sort order="descending" select="position()"/>
DROP TABLE <xsl:value-of select="name"/>
;
</xsl:for-each>

<xsl:apply-templates select="all/entity" />
<xsl:apply-templates select="all/Relationentity" />
<xsl:apply-templates select="all" />
</xsl:template>

<xsl:template match="all/entity">
<xsl:variable name="first">
 <xsl:value-of select="id" />
</xsl:variable>
<xsl:variable name="second">
 <xsl:value-of select="name" />
</xsl:variable>
<!-- Next create Many to one related Entity as Table-->
CREATE TABLE <xsl:value-of select="name" /> (
<xsl:for-each select="attri">
<xsl:value-of select="name" /><xsl:text> </xsl:text><xsl:value-of select="type" /><xsl:if test="type='VARCHAR' or type='CHAR' or type='NUMERIC'">(<xsl:value-of select="length" />)</xsl:if><xsl:text> </xsl:text><xsl:value-of select="compu" /> <xsl:if test="default=not(empty)"><xsl:text> </xsl:text><xsl:value-of select="default" /></xsl:if>,
</xsl:for-each>
<xsl:for-each select="ref/attrib">
<xsl:value-of select="tablename"/>_<xsl:value-of select="name"/><xsl:text> </xsl:text><xsl:value-of select="type"/><xsl:if test="type='VARCHAR' or type='CHAR' or type='NUMERIC'">(<xsl:value-of select="length" />)</xsl:if><xsl:text> </xsl:text><xsl:value-of select="compu" /><xsl:if test="default=not(empty)"><xsl:text> </xsl:text><xsl:value-of select="default" /></xsl:if>,
</xsl:for-each>
CONSTRAINT <xsl:value-of select="$second"/>_PK <!-- If attribute exists with value of primarykey-->
	PRIMARY KEY (<xsl:for-each select="attri[primary]"><xsl:value-of select="name"/><xsl:if test="not(position()=last()) and (last()>1)">,</xsl:if></xsl:for-each>)<xsl:for-each select="ref/attrib[not(tablename=preceding-sibling::attrib/tablename)]">,
CONSTRAINT <xsl:value-of select="$second"/>_<xsl:value-of select="name"/> <!-- Here is selected references from other tables to this table with primarykey-->
	FOREIGN KEY (<xsl:value-of select="tablename"/>_<xsl:value-of select="name"/><xsl:for-each select="../attrib[tablename/text()=current()/tablename/text() and not(id/text()=current()/id/text())]">,<xsl:value-of select="tablename"/>_<xsl:value-of select="name"/></xsl:for-each>)
	REFERENCES <xsl:value-of select="tablename"/> (<xsl:value-of select="name"/><xsl:for-each select="../attrib[tablename/text()=current()/tablename/text() and not(id/text()=current()/id/text())]">,<xsl:value-of select="name"/></xsl:for-each>)
		ON DELETE NO ACTION
		ON UPDATE CASCADE<xsl:if test="not(//ref/attrib[last()])">,</xsl:if>
</xsl:for-each>
<xsl:for-each select="attri/range">
CONSTRAINT <xsl:value-of select="//attri/name"/>_<xsl:value-of select="//attri/name"/>
	CHECK(<xsl:value-of select="//attri/name"/> <xsl:value-of select="./."/>)
</xsl:for-each>
)
;
</xsl:template>

<xsl:template match="all/Relationentity">
<xsl:variable name="first">
 <xsl:value-of select="id" />
</xsl:variable>
<xsl:variable name="second">
 <xsl:value-of select="name" />
</xsl:variable>
<!-- Next create Many to Many Relationship from Entity as Table-->
CREATE TABLE <xsl:value-of select="name" /> (
<xsl:for-each select="attri"> <!-- Selected every attribute with name and values-->
<xsl:value-of select="name" /><xsl:text> </xsl:text><xsl:value-of select="type" /><xsl:if test="type='VARCHAR' or type='CHAR' or type='NUMERIC'">(<xsl:value-of select="length" />)</xsl:if><xsl:text> </xsl:text><xsl:value-of select="compu" /> <xsl:if test="default=not(empty)"><xsl:text> </xsl:text><xsl:value-of select="default" /></xsl:if>,
</xsl:for-each>
<xsl:for-each select="ref/attrib">
<xsl:value-of select="tablename"/>_<xsl:value-of select="name"/><xsl:text> </xsl:text><xsl:value-of select="type"/><xsl:if test="type='VARCHAR' or type='CHAR' or type='NUMERIC'">(<xsl:value-of select="length" />)</xsl:if><xsl:text> </xsl:text><xsl:value-of select="compu" /><xsl:if test="default=not(empty)"><xsl:text> </xsl:text><xsl:value-of select="default" /></xsl:if>,
</xsl:for-each>
CONSTRAINT <xsl:value-of select="$second"/>_PK
	PRIMARY KEY (<xsl:for-each select="ref/attrib"><xsl:if test="primary=not(empty)"><xsl:value-of select="tablename"/>_<xsl:value-of select="name"/><xsl:if test="not(name = parent::node()/attrib[last()]/name)">,</xsl:if></xsl:if></xsl:for-each><xsl:for-each select="attri"><xsl:if test="primary=not(empty)">,<xsl:value-of select="name"/></xsl:if></xsl:for-each>)<xsl:for-each select="ref/attrib[not(tablename=preceding-sibling::attrib/tablename)]">,
CONSTRAINT <xsl:value-of select="$second"/>_<xsl:value-of select="name"/> <!-- Here is selected references from other tables to this table with primarykey-->
	FOREIGN KEY (<xsl:value-of select="tablename"/>_<xsl:value-of select="name"/><xsl:for-each select="../attrib[tablename/text()=current()/tablename/text() and not(id/text()=current()/id/text())]">,<xsl:value-of select="tablename"/>_<xsl:value-of select="name"/></xsl:for-each>)
	REFERENCES <xsl:value-of select="tablename"/> (<xsl:value-of select="name"/><xsl:for-each select="../attrib[tablename/text()=current()/tablename/text() and not(id/text()=current()/id/text())]">,<xsl:value-of select="name"/></xsl:for-each>)
		ON DELETE NO ACTION
		ON UPDATE CASCADE<xsl:if test="not(//ref/attrib[last()])">,</xsl:if>
</xsl:for-each>
<xsl:for-each select="attri/range">,
CONSTRAINT <xsl:value-of select="//attri/name"/>_<xsl:value-of select="//attri/name"/>
	CHECK(<xsl:value-of select="//attri/name"/> <xsl:value-of select="./."/>) <!-- Here is Table's attribute's values check-->
</xsl:for-each>
)
;
</xsl:template>

<xsl:template match="all"> <!-- Here is created indexs -->
<xsl:for-each select="entity">
<xsl:for-each select="attri">
<xsl:if test="index='true'">
CREATE INDEX<xsl:text> </xsl:text><xsl:value-of select="//name"/>_<xsl:value-of select="name"/><xsl:text> </xsl:text>ON<xsl:text> </xsl:text><xsl:value-of select="//name"/>(<xsl:value-of select="name"/>)
;</xsl:if>

</xsl:for-each>
</xsl:for-each>
</xsl:template>

</xsl:stylesheet>
